
;CodeVisionAVR C Compiler V2.03.9 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8L
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : float, width, precision
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8L
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _sek=R5
	.DEF _minut=R4
	.DEF _hour=R7
	.DEF _mode=R6
	.DEF _val=R9
	.DEF _m_about=R8
	.DEF _m_vol=R11
	.DEF _m_trbl=R10
	.DEF _m_bass=R13
	.DEF _m_set=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_b_val:
	.DB  0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17
	.DB  0x1E,0x1D,0x1C,0x1B,0x1A,0x19,0x18
_t_val:
	.DB  0xE,0x1E,0x2E,0x3E,0x4E,0x5E,0x6E,0x7E
	.DB  0xEE,0xDE,0xCE,0xBE,0xAE,0x9E,0x8E
_v_val:
	.DB  0x0,0x4,0x8,0xC,0x10,0x14,0x18,0x1C
	.DB  0x20,0x24,0x28,0x2C,0x30,0x34,0x38,0x3C
	.DB  0x40,0x44,0x48,0x4C
_FontLookup:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0xC4,0xC8,0x10,0x26,0x46,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x0,0x50,0x30
	.DB  0x0,0x10,0x10,0x10,0x10,0x10,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x3E,0x51,0x49,0x45,0x3E,0x0,0x42,0x7F
	.DB  0x40,0x0,0x42,0x61,0x51,0x49,0x46,0x21
	.DB  0x41,0x45,0x4B,0x31,0x18,0x14,0x12,0x7F
	.DB  0x10,0x27,0x45,0x45,0x45,0x39,0x3C,0x4A
	.DB  0x49,0x49,0x30,0x1,0x71,0x9,0x5,0x3
	.DB  0x36,0x49,0x49,0x49,0x36,0x6,0x49,0x49
	.DB  0x29,0x1E,0x0,0x36,0x36,0x0,0x0,0x0
	.DB  0x56,0x36,0x0,0x0,0x8,0x14,0x22,0x41
	.DB  0x0,0x14,0x14,0x14,0x14,0x14,0x0,0x41
	.DB  0x22,0x14,0x8,0x2,0x1,0x51,0x9,0x6
	.DB  0x32,0x49,0x59,0x51,0x3E,0x7E,0x11,0x11
	.DB  0x11,0x7E,0x7F,0x49,0x49,0x49,0x36,0x3E
	.DB  0x41,0x41,0x41,0x22,0x7F,0x41,0x41,0x22
	.DB  0x1C,0x7F,0x49,0x49,0x49,0x41,0x7F,0x9
	.DB  0x9,0x9,0x1,0x3E,0x41,0x49,0x49,0x7A
	.DB  0x7F,0x8,0x8,0x8,0x7F,0x0,0x41,0x7F
	.DB  0x41,0x0,0x20,0x40,0x41,0x3F,0x1,0x7F
	.DB  0x8,0x14,0x22,0x41,0x7F,0x40,0x40,0x40
	.DB  0x40,0x7F,0x2,0xC,0x2,0x7F,0x7F,0x4
	.DB  0x8,0x10,0x7F,0x3E,0x41,0x41,0x41,0x3E
	.DB  0x7F,0x9,0x9,0x9,0x6,0x3E,0x41,0x51
	.DB  0x21,0x5E,0x7F,0x9,0x19,0x29,0x46,0x46
	.DB  0x49,0x49,0x49,0x31,0x1,0x1,0x7F,0x1
	.DB  0x1,0x3F,0x40,0x40,0x40,0x3F,0x1F,0x20
	.DB  0x40,0x20,0x1F,0x3F,0x40,0x38,0x40,0x3F
	.DB  0x63,0x14,0x8,0x14,0x63,0x7,0x8,0x70
	.DB  0x8,0x7,0x61,0x51,0x49,0x45,0x43,0x0
	.DB  0x7F,0x41,0x41,0x0,0x55,0x2A,0x55,0x2A
	.DB  0x55,0x0,0x41,0x41,0x7F,0x0,0x4,0x2
	.DB  0x1,0x2,0x4,0x40,0x40,0x40,0x40,0x40
	.DB  0x0,0x1,0x2,0x4,0x0,0x20,0x54,0x54
	.DB  0x54,0x78,0x7F,0x48,0x44,0x44,0x38,0x38
	.DB  0x44,0x44,0x44,0x20,0x38,0x44,0x44,0x48
	.DB  0x7F,0x38,0x54,0x54,0x54,0x18,0x8,0x7E
	.DB  0x9,0x1,0x2,0xC,0x52,0x52,0x52,0x3E
	.DB  0x7F,0x8,0x4,0x4,0x78,0x0,0x44,0x7D
	.DB  0x40,0x0,0x20,0x40,0x44,0x3D,0x0,0x7F
	.DB  0x10,0x28,0x44,0x0,0x0,0x41,0x7F,0x40
	.DB  0x0,0x7C,0x4,0x18,0x4,0x78,0x7C,0x8
	.DB  0x4,0x4,0x78,0x38,0x44,0x44,0x44,0x38
	.DB  0x7C,0x14,0x14,0x14,0x8,0x8,0x14,0x14
	.DB  0x18,0x7C,0x7C,0x8,0x4,0x4,0x8,0x48
	.DB  0x54,0x54,0x54,0x20,0x4,0x3F,0x44,0x40
	.DB  0x20,0x3C,0x40,0x40,0x20,0x7C,0x1C,0x20
	.DB  0x40,0x20,0x1C,0x3C,0x40,0x30,0x40,0x3C
	.DB  0x44,0x28,0x10,0x28,0x44,0xC,0x50,0x50
	.DB  0x50,0x3C,0x44,0x64,0x54,0x4C,0x44,0x0
	.DB  0x8,0x36,0x41,0x0,0x0,0x0,0x7F,0x0
	.DB  0x0,0x0,0x41,0x36,0x8,0x0,0x4,0x2
	.DB  0x4,0x8,0x4,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x36,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x3E,0x49,0x49,0x49,0x22,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x44,0x45,0x7C,0x45,0x44
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x41,0x7F,0x41,0x0,0x0
	.DB  0x44,0x7D,0x40,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x38,0x54,0x44,0x28,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x4A,0x48,0x7A,0x40,0x40
	.DB  0x7E,0x11,0x11,0x11,0x7E,0x7F,0x49,0x49
	.DB  0x49,0x31,0x7F,0x49,0x49,0x49,0x36,0x7F
	.DB  0x1,0x1,0x1,0x3,0x60,0x3E,0x21,0x21
	.DB  0x7F,0x7F,0x49,0x49,0x49,0x41,0x63,0x14
	.DB  0x7F,0x14,0x63,0x22,0x49,0x49,0x49,0x36
	.DB  0x7F,0x10,0x8,0x4,0x7F,0x7F,0x10,0x9
	.DB  0x4,0x7F,0x7F,0x8,0x14,0x22,0x41,0x7C
	.DB  0x2,0x1,0x1,0x7F,0x7F,0x2,0xC,0x2
	.DB  0x7F,0x7F,0x8,0x8,0x8,0x7F,0x3E,0x41
	.DB  0x41,0x41,0x3E,0x7F,0x1,0x1,0x1,0x7F
	.DB  0x7F,0x9,0x9,0x9,0x6,0x3E,0x41,0x41
	.DB  0x41,0x22,0x1,0x1,0x7F,0x1,0x1,0x7
	.DB  0x48,0x48,0x48,0x3F,0x1C,0x22,0x7F,0x22
	.DB  0x1C,0x63,0x14,0x8,0x14,0x63,0x3F,0x20
	.DB  0x20,0x3F,0x60,0x7,0x8,0x8,0x8,0x7F
	.DB  0x7F,0x40,0x7F,0x40,0x7F,0x3F,0x20,0x3F
	.DB  0x20,0x7F,0x1,0x7F,0x48,0x48,0x30,0x7F
	.DB  0x48,0x48,0x30,0x7F,0x7F,0x48,0x48,0x48
	.DB  0x30,0x22,0x49,0x49,0x49,0x3E,0x7F,0x8
	.DB  0x3E,0x41,0x3E,0x46,0x29,0x19,0x9,0x7F
	.DB  0x20,0x54,0x54,0x54,0x78,0x78,0x54,0x54
	.DB  0x54,0x20,0x7C,0x54,0x54,0x54,0x28,0x7C
	.DB  0x4,0x4,0x4,0x0,0x60,0x38,0x24,0x38
	.DB  0x60,0x38,0x54,0x54,0x54,0x18,0x6C,0x10
	.DB  0x7C,0x10,0x6C,0x28,0x44,0x54,0x54,0x28
	.DB  0x3C,0x40,0x40,0x20,0x7C,0x3C,0x40,0x42
	.DB  0x20,0x7C,0x7C,0x10,0x10,0x28,0x44,0x60
	.DB  0x10,0x8,0x4,0x7C,0x7C,0x8,0x10,0x8
	.DB  0x7C,0x7C,0x10,0x10,0x10,0x7C,0x38,0x44
	.DB  0x44,0x44,0x38,0x7C,0x4,0x4,0x4,0x7C
	.DB  0x7C,0x14,0x14,0x14,0x8,0x38,0x44,0x44
	.DB  0x44,0x20,0x4,0x4,0x7C,0x4,0x4,0xC
	.DB  0x50,0x50,0x50,0x3C,0x18,0x24,0x7C,0x24
	.DB  0x18,0x44,0x28,0x10,0x28,0x44,0x3C,0x20
	.DB  0x20,0x3C,0x60,0xC,0x10,0x10,0x10,0x7C
	.DB  0x7C,0x40,0x7C,0x40,0x7C,0x3C,0x20,0x3C
	.DB  0x20,0x7C,0x4,0x7C,0x48,0x48,0x30,0x7C
	.DB  0x48,0x30,0x0,0x7C,0x7C,0x48,0x48,0x48
	.DB  0x30,0x28,0x44,0x54,0x54,0x38,0x7C,0x10
	.DB  0x38,0x44,0x38,0x58,0x24,0x24,0x24,0x7C
_deg12x16:
	.DB  0x0,0xF8,0xFE,0x6,0x3,0x3,0x3,0x3
	.DB  0x3,0x6,0xFE,0xF8,0x0,0x7,0x1F,0x18
	.DB  0x30,0x30,0x30,0x30,0x30,0x18,0x1F,0x7
	.DB  0x0,0x0,0x0,0xC,0xC,0xE,0xFF,0xFF
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x30
	.DB  0x30,0x30,0x3F,0x3F,0x30,0x30,0x30,0x0
	.DB  0x0,0x1C,0x1E,0x7,0x3,0x3,0x83,0xC3
	.DB  0xE3,0x77,0x3E,0x1C,0x0,0x30,0x38,0x3C
	.DB  0x3E,0x37,0x33,0x31,0x30,0x30,0x30,0x30
	.DB  0x0,0xC,0xE,0x7,0xC3,0xC3,0xC3,0xC3
	.DB  0xC3,0xE7,0x7E,0x3C,0x0,0xC,0x1C,0x38
	.DB  0x30,0x30,0x30,0x30,0x30,0x39,0x1F,0xE
	.DB  0x0,0xC0,0xE0,0x70,0x38,0x1C,0xE,0x7
	.DB  0xFF,0xFF,0x0,0x0,0x0,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3F,0x3F,0x3,0x3
	.DB  0x0,0x3F,0x7F,0x63,0x63,0x63,0x63,0x63
	.DB  0x63,0xE3,0xC3,0x83,0x0,0xC,0x1C,0x38
	.DB  0x30,0x30,0x30,0x30,0x30,0x38,0x1F,0xF
	.DB  0x0,0xC0,0xF0,0xF8,0xDC,0xCE,0xC7,0xC3
	.DB  0xC3,0xC3,0x80,0x0,0x0,0xF,0x1F,0x39
	.DB  0x30,0x30,0x30,0x30,0x30,0x39,0x1F,0xF
	.DB  0x0,0x3,0x3,0x3,0x3,0x3,0x3,0xC3
	.DB  0xF3,0x3F,0xF,0x3,0x0,0x0,0x0,0x0
	.DB  0x30,0x3C,0xF,0x3,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0xBC,0xFE,0xE7,0xC3,0xC3,0xC3
	.DB  0xE7,0xFE,0xBC,0x0,0x0,0xF,0x1F,0x39
	.DB  0x30,0x30,0x30,0x30,0x30,0x39,0x1F,0xF
	.DB  0x0,0x3C,0x7E,0xE7,0xC3,0xC3,0xC3,0xC3
	.DB  0xC3,0xE7,0xFE,0xFC,0x0,0x0,0x0,0x30
	.DB  0x30,0x30,0x38,0x1C,0xE,0x7,0x3,0x0
	.DB  0xE0,0xF0,0xF8,0xF8,0xF8,0xF0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x1,0x61,0x71
	.DB  0x3F,0xF,0x0,0x0,0x0,0x0,0x0,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0001

_0x3:
	.DB  0x5
_0x4:
	.DB  0x6
_0x5:
	.DB  0x4
_0x6:
	.DB  0x3
_0x7:
	.DB  0x1
_0x8:
	.DB  0x0,0xFC,0xF8,0xF4,0xF0,0xEC,0xE8,0xE4
	.DB  0xE0,0xDC,0xD8,0xD4,0xD0,0xCC,0xC8,0xC4
	.DB  0xC0,0xBC,0xB8,0xB4
_0x9:
	.DB  0x1
_0xA:
	.DB  0xFA,0x8C,0xF8,0x54,0x22,0x51,0xFF,0x4
	.DB  0x2,0x0,0x2,0x1,0x0,0x1,0x2,0x4
	.DB  0x7,0x1,0x2
_0x3E:
	.DB  0x0,0x0,0x2,0x1,0x4,0x3
_0x0:
	.DB  0x20,0x20,0x0,0xC3,0xF0,0xEE,0xEC,0xEA
	.DB  0xEE,0xF1,0xF2,0xFC,0x0,0x20,0xC2,0xFB
	.DB  0xF1,0xEE,0xEA,0xE8,0xE5,0x20,0x20,0x0
	.DB  0x20,0xCD,0xE8,0xE7,0xEA,0xE8,0xE5,0x20
	.DB  0x20,0x0,0xD3,0xF1,0xF2,0xE0,0xED,0xEE
	.DB  0xE2,0xEA,0xE0,0x20,0x0,0xE2,0xF0,0xE5
	.DB  0xEC,0xE5,0xED,0xE8,0x20,0x0,0x30,0x30
	.DB  0x20,0x30,0x30,0x0
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0
_0x20A005F:
	.DB  0x1
_0x20A0000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x01
	.DW  _vl_adr
	.DW  _0x3*2

	.DW  0x01
	.DW  _vr_adr
	.DW  _0x4*2

	.DW  0x01
	.DW  _t_adr
	.DW  _0x5*2

	.DW  0x01
	.DW  _b_adr
	.DW  _0x6*2

	.DW  0x01
	.DW  _Mode_Change_Enabled
	.DW  _0x9*2

	.DW  0x13
	.DW  _volum_G000
	.DW  _0xA*2

	.DW  0x06
	.DW  0x08
	.DW  _0x3E*2

	.DW  0x01
	.DW  __seed_G105
	.DW  _0x20A005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.03.9 Standard
;Automatic Program Generator
; Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 30.09.2011
;Author  : Admin
;Company : Microsoft
;Comments:
;
;
;Chip type               : ATmega8L
;Program type            : Application
;AVR Core Clock frequency: 4,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <1100.h>
;#include <stdio.h>
;#include <delay.h>
;
;// I2C Bus functions
;#asm
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=4
   .equ __scl_bit=5
; 0000 0022 #endasm
;#include <i2c.h>
;
;unsigned char sek;
;unsigned char minut;
;unsigned char hour;
;
;bit fflag = 1;  // 
;unsigned char mode;
;
;#define UP_Button    (!PINC.2)  //   
;#define DOWN_Button  (!PINC.3)  //   
;#define MODE_Button  (!PINC.0)  //    
;#define MUTE_Button  (!PINC.1)  //   mute
;
;//,     
;#define KEY_NULL      0
;
;char val = 0;
;
;const char m_about = 0,
;m_vol = 1,
;m_trbl = 2,
;m_bass = 3,
;m_set = 4;
;//m_mute = 5;
;
;char about, vol, trbl, bass, set, mute = 0, vol_tmp;
;double timer=0;
;
;const char vl_adr = 0b00000101,

	.DSEG
;vr_adr = 0b00000110,
;t_adr = 0b00000100,
;b_adr = 0b00000011,
;s_adr = 0b00000001;
;
;
;
;flash char b_val[15] = {
;0b00010000,
;0b00010001,
;0b00010010,
;0b00010011,
;0b00010100,
;0b00010101,
;0b00010110,
;0b00010111,
;0b00011110,
;0b00011101,
;0b00011100,
;0b00011011,
;0b00011010,
;0b00011001,
;0b00011000
;};
;
;flash char t_val[15] = {
;0b00001110,
;0b00011110,
;0b00101110,
;0b00111110,
;0b01001110,
;0b01011110,
;0b01101110,
;0b01111110,
;0b11101110,
;0b11011110,
;0b11001110,
;0b10111110,
;0b10101110,
;0b10011110,
;0b10001110
;};
;
;flash char v_val[20] = {
;0b00000000,
;0b00000100,
;0b00001000,
;0b00001100,
;0b00010000,
;0b00010100,
;0b00011000,
;0b00011100,
;0b00100000,
;0b00100100,
;0b00101000,
;0b00101100,
;0b00110000,
;0b00110100,
;0b00111000,
;0b00111100,
;0b01000000,
;0b01000100,
;0b01001000,
;0b01001100
;};
;
;static const char v_val_t[20] =
;{0,-4,-8,-12,-16,-20,-24,-28,-32,-36,
;-40,-44,-48,-52,-56,-60,-64,-68,-72,-76 };
;
;unsigned char Mode_Change_Enabled = 1;    //   
;
;static const char volum[20] ={
;0xFA,0x8C,0xF8,0x54,0x22,0x51,0xFF,0x04,0x02,0x00,
;0x02,0x01,0x00,0x01,0x02,0x04,0x07,0x01,0x02,0x00
;};
;
;//static const char trble[10] ={
;//0xF8,0xF0,0xEC,0xCC,0x83,0x83,0xCC,0xEC,0xF0,0xF8
;//};
;
;void tda_send(char sba, char dt)
; 0000 0093 {

	.CSEG
_tda_send:
; 0000 0094    i2c_start();
;	sba -> Y+1
;	dt -> Y+0
	RCALL _i2c_start
; 0000 0095    i2c_write(0b10000000);
	LDI  R30,LOW(128)
	ST   -Y,R30
	RCALL _i2c_write
; 0000 0096    i2c_write(sba);
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _i2c_write
; 0000 0097    i2c_write(dt);
	LD   R30,Y
	ST   -Y,R30
	RCALL _i2c_write
; 0000 0098    i2c_stop();
	RCALL _i2c_stop
; 0000 0099 }
	RJMP _0x20C0002
;eeprom char e_vol;
;eeprom char e_bass;
;eeprom char e_trbl;
;eeprom char e_set;
;// Timer 1 output compare A interrupt service routine
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)
; 0000 00A0 {
_timer1_compa_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 00A1 // Place your code here
; 0000 00A2 TCNT1H=0;
	RCALL SUBOPT_0x0
; 0000 00A3 TCNT1L=0;
; 0000 00A4 sek++;
	INC  R5
; 0000 00A5 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;// Declare your global variables here
;
;void main(void)
; 0000 00AA {
_main:
; 0000 00AB // Declare your local variables here
; 0000 00AC 
; 0000 00AD // Input/Output Ports initialization
; 0000 00AE // Port B initialization
; 0000 00AF // Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=In Func0=In
; 0000 00B0 // State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=P State0=P
; 0000 00B1 PORTB=0x03;
	LDI  R30,LOW(3)
	OUT  0x18,R30
; 0000 00B2 DDRB=0x3C;
	LDI  R30,LOW(60)
	OUT  0x17,R30
; 0000 00B3 
; 0000 00B4 // Port C initialization
; 0000 00B5 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 00B6 // State6=T State5=T State4=T State3=T State2=T State1=P State0=P
; 0000 00B7 PORTC=0x0F;
	LDI  R30,LOW(15)
	OUT  0x15,R30
; 0000 00B8 DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
; 0000 00B9 
; 0000 00BA // Port D initialization
; 0000 00BB // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 00BC // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 00BD PORTD=0x00;
	OUT  0x12,R30
; 0000 00BE DDRD=0x00;
	OUT  0x11,R30
; 0000 00BF 
; 0000 00C0 // Timer/Counter 0 initialization
; 0000 00C1 // Clock source: System Clock
; 0000 00C2 // Clock value: Timer 0 Stopped
; 0000 00C3 TCCR0=0x00;
	OUT  0x33,R30
; 0000 00C4 TCNT0=0x00;
	OUT  0x32,R30
; 0000 00C5 
; 0000 00C6 // Timer/Counter 1 initialization
; 0000 00C7 // Clock source: System Clock
; 0000 00C8 // Clock value: Timer 1 Stopped
; 0000 00C9 // Mode: Normal top=FFFFh
; 0000 00CA // OC1A output: Discon.
; 0000 00CB // OC1B output: Discon.
; 0000 00CC // Noise Canceler: Off
; 0000 00CD // Input Capture on Falling Edge
; 0000 00CE // Timer 1 Overflow Interrupt: Off
; 0000 00CF // Input Capture Interrupt: Off
; 0000 00D0 // Compare A Match Interrupt: Off
; 0000 00D1 // Compare B Match Interrupt: Off
; 0000 00D2 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 00D3 TCCR1B=0x03;
	LDI  R30,LOW(3)
	OUT  0x2E,R30
; 0000 00D4 TCNT1H=0x00;
	RCALL SUBOPT_0x0
; 0000 00D5 TCNT1L=0x00;
; 0000 00D6 ICR1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x27,R30
; 0000 00D7 ICR1L=0x00;
	OUT  0x26,R30
; 0000 00D8 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00D9 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00DA OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00DB OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00DC 
; 0000 00DD // Timer/Counter 2 initialization
; 0000 00DE // Clock source: System Clock
; 0000 00DF // Clock value: Timer 2 Stopped
; 0000 00E0 // Mode: Normal top=FFh
; 0000 00E1 // OC2 output: Disconnected
; 0000 00E2 ASSR=0x00;
	OUT  0x22,R30
; 0000 00E3 TCCR2=0x00;
	OUT  0x25,R30
; 0000 00E4 TCNT2=0x00;
	OUT  0x24,R30
; 0000 00E5 OCR2=0x00;
	OUT  0x23,R30
; 0000 00E6 
; 0000 00E7 // External Interrupt(s) initialization
; 0000 00E8 // INT0: Off
; 0000 00E9 // INT1: Off
; 0000 00EA MCUCR=0x00;
	OUT  0x35,R30
; 0000 00EB 
; 0000 00EC // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00ED TIMSK=0x10;
	LDI  R30,LOW(16)
	OUT  0x39,R30
; 0000 00EE 
; 0000 00EF // Analog Comparator initialization
; 0000 00F0 // Analog Comparator: Off
; 0000 00F1 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 00F2 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00F3 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00F4 
; 0000 00F5 
; 0000 00F6 
; 0000 00F7 // I2C Bus initialization
; 0000 00F8 i2c_init();
	RCALL _i2c_init
; 0000 00F9 
; 0000 00FA lcd_init();
	RCALL _lcd_init
; 0000 00FB mode = 0;
	CLR  R6
; 0000 00FC vol = e_vol;
	LDI  R26,LOW(_e_vol)
	LDI  R27,HIGH(_e_vol)
	RCALL __EEPROMRDB
	RCALL SUBOPT_0x1
; 0000 00FD trbl = e_trbl;
	LDI  R26,LOW(_e_trbl)
	LDI  R27,HIGH(_e_trbl)
	RCALL __EEPROMRDB
	STS  _trbl,R30
; 0000 00FE bass = e_bass;
	LDI  R26,LOW(_e_bass)
	LDI  R27,HIGH(_e_bass)
	RCALL __EEPROMRDB
	STS  _bass,R30
; 0000 00FF set = e_set;
	LDI  R26,LOW(_e_set)
	LDI  R27,HIGH(_e_set)
	RCALL __EEPROMRDB
	STS  _set,R30
; 0000 0100 
; 0000 0101 lcd_clear();
	RCALL _lcd_clear
; 0000 0102 
; 0000 0103 //tda_send(s_adr, s_val[surr]);
; 0000 0104 tda_send(vl_adr, v_val[vol]);
	RCALL SUBOPT_0x2
; 0000 0105 tda_send(vr_adr, v_val[vol]);
; 0000 0106 tda_send(t_adr, t_val[trbl]);
	RCALL SUBOPT_0x3
; 0000 0107 tda_send(b_adr, b_val[bass]);
	RCALL SUBOPT_0x4
; 0000 0108 tda_send(0x00, 0x00);
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x5
	RCALL _tda_send
; 0000 0109 
; 0000 010A 
; 0000 010B #asm("sei")
	sei
; 0000 010C while (1)
_0xB:
; 0000 010D       {
; 0000 010E       // Place your code here
; 0000 010F       unsigned char i;
; 0000 0110       unsigned char key;
; 0000 0111       //***********************************
; 0000 0112 
; 0000 0113       //  .
; 0000 0114        if(sek==60) //   = 60
	SBIW R28,2
;	i -> Y+1
;	key -> Y+0
	LDI  R30,LOW(60)
	CP   R30,R5
	BRNE _0xE
; 0000 0115        {
; 0000 0116        minut++; //  1   ""
	INC  R4
; 0000 0117        sek=0; //   ""
	CLR  R5
; 0000 0118        }
; 0000 0119        if(minut==60) //   = 60
_0xE:
	LDI  R30,LOW(60)
	CP   R30,R4
	BRNE _0xF
; 0000 011A        {
; 0000 011B        hour++; //  1   ""
	INC  R7
; 0000 011C        minut=0; //   ""
	CLR  R4
; 0000 011D        }
; 0000 011E        if (hour==24) //       24  
_0xF:
	LDI  R30,LOW(24)
	CP   R30,R7
	BRNE _0x10
; 0000 011F        { //   24 ,   .
; 0000 0120        hour=0;
	CLR  R7
; 0000 0121        minut=0;
	CLR  R4
; 0000 0122        sek=0;
	CLR  R5
; 0000 0123        }
; 0000 0124        //   ,             .
; 0000 0125        if (hour==255)
_0x10:
	LDI  R30,LOW(255)
	CP   R30,R7
	BRNE _0x11
; 0000 0126        hour=0;
	CLR  R7
; 0000 0127        if (minut==255)
_0x11:
	LDI  R30,LOW(255)
	CP   R30,R4
	BRNE _0x12
; 0000 0128        minut=0;
	CLR  R4
; 0000 0129        //***********************************
; 0000 012A 
; 0000 012B        // 
; 0000 012C        if((mode != 0)&&(KEY_NULL)&&(timer < 10000)) timer = timer + 1;
_0x12:
	LDI  R30,LOW(0)
	CP   R30,R6
	BREQ _0x14
	CPI  R30,0
	BREQ _0x14
	RCALL SUBOPT_0x6
	__GETD1N 0x461C4000
	RCALL __CMPF12
	BRLO _0x15
_0x14:
	RJMP _0x13
_0x15:
	LDS  R30,_timer
	LDS  R31,_timer+1
	LDS  R22,_timer+2
	LDS  R23,_timer+3
	__GETD2N 0x3F800000
	RCALL __ADDF12
	STS  _timer,R30
	STS  _timer+1,R31
	STS  _timer+2,R22
	STS  _timer+3,R23
; 0000 012D        if(timer == 10000) {
_0x13:
	RCALL SUBOPT_0x6
	__CPD2N 0x461C4000
	BRNE _0x16
; 0000 012E        mode = 0;
	CLR  R6
; 0000 012F        timer = 0;
	RCALL SUBOPT_0x7
; 0000 0130        fflag = 0;
	RCALL SUBOPT_0x8
; 0000 0131        lcd_clear();
	RCALL _lcd_clear
; 0000 0132        };
_0x16:
; 0000 0133        //***********************************
; 0000 0134 
; 0000 0135        // 
; 0000 0136        if (MUTE_Button) {
	SBIC 0x13,1
	RJMP _0x17
; 0000 0137          delay_ms(200);
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RCALL SUBOPT_0x9
	RCALL _delay_ms
; 0000 0138 
; 0000 0139          if (mute==0) {
	LDS  R30,_mute
	CPI  R30,0
	BRNE _0x18
; 0000 013A          mute=1;
	LDI  R30,LOW(1)
	RCALL SUBOPT_0xA
; 0000 013B 
; 0000 013C          gotoxy(5,1);
; 0000 013D           for ( i = 0; i != 10; i++ ){
	LDI  R30,LOW(0)
	STD  Y+1,R30
_0x1A:
	LDD  R26,Y+1
	CPI  R26,LOW(0xA)
	BREQ _0x1B
; 0000 013E           gotoxy(5+i, 1);
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xC
	RCALL _gotoxy
; 0000 013F           lcd_write(DATA,volum[i]);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	SUBI R30,LOW(-_volum_G000)
	SBCI R31,HIGH(-_volum_G000)
	LD   R30,Z
	RCALL SUBOPT_0xE
; 0000 0140           gotoxy(5+i, 2);
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xF
; 0000 0141           lcd_write(DATA,volum[10+i]);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	__ADDW1MN _volum_G000,10
	LD   R30,Z
	RCALL SUBOPT_0xE
; 0000 0142           }
	LDD  R30,Y+1
	SUBI R30,-LOW(1)
	STD  Y+1,R30
	RJMP _0x1A
_0x1B:
; 0000 0143          }
; 0000 0144          else
	RJMP _0x1C
_0x18:
; 0000 0145          {
; 0000 0146          mute=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xA
; 0000 0147 
; 0000 0148          gotoxy(5,1); print_message("  ");
	RCALL SUBOPT_0x10
; 0000 0149          gotoxy(5,2); print_message("  ");
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x10
; 0000 014A          };
_0x1C:
; 0000 014B 
; 0000 014C        };
_0x17:
; 0000 014D        //***********************************
; 0000 014E 
; 0000 014F        //
; 0000 0150        if ((UP_Button)&&(mode==1)) {
	SBIC 0x13,2
	RJMP _0x1E
	LDI  R30,LOW(1)
	CP   R30,R6
	BREQ _0x1F
_0x1E:
	RJMP _0x1D
_0x1F:
; 0000 0151           delay_ms(50); mute=0;
	RCALL SUBOPT_0x12
; 0000 0152           gotoxy(5,1); print_message("  ");
	RCALL SUBOPT_0x10
; 0000 0153           gotoxy(5,2); print_message("  ");
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x10
; 0000 0154 
; 0000 0155        };
_0x1D:
; 0000 0156 
; 0000 0157        if ((DOWN_Button)&&(mode==1)) {
	SBIC 0x13,3
	RJMP _0x21
	LDI  R30,LOW(1)
	CP   R30,R6
	BREQ _0x22
_0x21:
	RJMP _0x20
_0x22:
; 0000 0158           delay_ms(50); mute=0;
	RCALL SUBOPT_0x12
; 0000 0159           gotoxy(5,1); print_message("  ");
	RCALL SUBOPT_0x10
; 0000 015A           gotoxy(5,2); print_message("  ");
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x10
; 0000 015B 
; 0000 015C        };
_0x20:
; 0000 015D       //****************************************
; 0000 015E 
; 0000 015F       // 
; 0000 0160       if (Mode_Change_Enabled)
	LDS  R30,_Mode_Change_Enabled
	CPI  R30,0
	BREQ _0x23
; 0000 0161         {
; 0000 0162             if (MODE_Button)                    //     
	SBIC 0x13,0
	RJMP _0x24
; 0000 0163             {   delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x13
; 0000 0164                 if ((mode++) == 4) mode = 0;    //   
	MOV  R30,R6
	INC  R6
	CPI  R30,LOW(0x4)
	BRNE _0x25
	CLR  R6
; 0000 0165                 Mode_Change_Enabled = 0;        //      
_0x25:
	LDI  R30,LOW(0)
	STS  _Mode_Change_Enabled,R30
; 0000 0166               fflag = 1;
	SET
	BLD  R2,0
; 0000 0167             };
_0x24:
; 0000 0168         }
; 0000 0169         //   ,    
; 0000 016A         else if (!MODE_Button) {Mode_Change_Enabled = 1;};
	RJMP _0x26
_0x23:
	SBIS 0x13,0
	RJMP _0x27
	LDI  R30,LOW(1)
	STS  _Mode_Change_Enabled,R30
_0x27:
_0x26:
; 0000 016B       //*****************************************
; 0000 016C 
; 0000 016D       //  (about)
; 0000 016E        if ((mode == 0) && (fflag == 1)) {
	LDI  R30,LOW(0)
	CP   R30,R6
	BRNE _0x29
	SBRC R2,0
	RJMP _0x2A
_0x29:
	RJMP _0x28
_0x2A:
; 0000 016F        lcd_clear();
	RCALL _lcd_clear
; 0000 0170 
; 0000 0171        //
; 0000 0172        char_12_16(hour/10,20,1);
	MOV  R26,R7
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0xC
	RCALL _char_12_16
; 0000 0173        char_12_16(hour%10,32,1);
	MOV  R26,R7
	RCALL SUBOPT_0x16
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL SUBOPT_0xC
	RCALL _char_12_16
; 0000 0174        char_12_16(minut/10,50,1);
	MOV  R26,R4
	RCALL SUBOPT_0x14
	LDI  R30,LOW(50)
	ST   -Y,R30
	RCALL SUBOPT_0xC
	RCALL _char_12_16
; 0000 0175        char_12_16(minut%10,62,1);
	MOV  R26,R4
	RCALL SUBOPT_0x16
	LDI  R30,LOW(62)
	ST   -Y,R30
	RCALL SUBOPT_0xC
	RCALL _char_12_16
; 0000 0176        delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RCALL SUBOPT_0x13
; 0000 0177 
; 0000 0178        //gotoxy(25,4); //print_message(" 220");
; 0000 0179        //gotoxy(3,6); print_message("               ");
; 0000 017A 
; 0000 017B        //gotoxy(5,6);
; 0000 017C          // for ( i = 0; i < 10; i++ ){
; 0000 017D           //gotoxy(5, 1);
; 0000 017E           //lcd_write(DATA,trble[i]);
; 0000 017F 
; 0000 0180           //}
; 0000 0181        //gotoxy(15,6); print_message("-           ");
; 0000 0182        //sprintf( TrblBuffer,"%d", trbl );
; 0000 0183        //gotoxy(15,6); print_string(TrblBuffer);
; 0000 0184 
; 0000 0185        fflag = 0;
	RCALL SUBOPT_0x8
; 0000 0186        };
_0x28:
; 0000 0187       //*****************************************
; 0000 0188 
; 0000 0189       //   (volum)
; 0000 018A        if ((mode==1)&&(fflag==1)) {
	LDI  R30,LOW(1)
	CP   R30,R6
	BRNE _0x2C
	SBRC R2,0
	RJMP _0x2D
_0x2C:
	RJMP _0x2B
_0x2D:
; 0000 018B        lcd_clear(); vol = vol_tmp;
	RCALL _lcd_clear
	LDS  R30,_vol_tmp
	RCALL SUBOPT_0x1
; 0000 018C         gotoxy(20,3); print_message("");
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
	__POINTW1FN _0x0,3
	RCALL SUBOPT_0x18
; 0000 018D 
; 0000 018E        //gotoxy(15,5); print_char(vol);
; 0000 018F          //char_12_16(vol,15,5);
; 0000 0190          if((UP_Button)&(vol < 19)) vol++;
	LDS  R26,_vol
	LDI  R30,LOW(19)
	RCALL __LTB12U
	AND  R30,R0
	BREQ _0x2E
	LDS  R30,_vol
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x1
; 0000 0191          if((DOWN_Button)&(vol > 0)) vol--;
_0x2E:
	RCALL SUBOPT_0x19
	LDS  R26,_vol
	RCALL SUBOPT_0x1A
	BREQ _0x2F
	LDS  R30,_vol
	SUBI R30,LOW(1)
	RCALL SUBOPT_0x1
; 0000 0192          tda_send(vl_adr, v_val[vol]);
_0x2F:
	RCALL SUBOPT_0x2
; 0000 0193          tda_send(vr_adr, v_val[vol]);
; 0000 0194          //gotoxy(3,5); print_string(v_val_t);
; 0000 0195          //e_vol = vol;
; 0000 0196 
; 0000 0197        fflag = 0;
	RCALL SUBOPT_0x8
; 0000 0198        timer = 0;
	RCALL SUBOPT_0x7
; 0000 0199        };
_0x2B:
; 0000 019A       //*****************************************
; 0000 019B 
; 0000 019C       //   (trbl)
; 0000 019D        if ((mode==2)&&(fflag==1)) {
	LDI  R30,LOW(2)
	CP   R30,R6
	BRNE _0x31
	SBRC R2,0
	RJMP _0x32
_0x31:
	RJMP _0x30
_0x32:
; 0000 019E        lcd_clear();
	RCALL _lcd_clear
; 0000 019F          gotoxy(20,3); print_message("   ");
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
	__POINTW1FN _0x0,13
	RCALL SUBOPT_0x18
; 0000 01A0          //gotoxy(15,5); print_char(trbl);
; 0000 01A1          //char_12_16('00',15,5);
; 0000 01A2          if((UP_Button)&(trbl < 14)) trbl++;
	LDS  R26,_trbl
	LDI  R30,LOW(14)
	RCALL __LTB12U
	AND  R30,R0
	BREQ _0x33
	LDS  R30,_trbl
	SUBI R30,-LOW(1)
	STS  _trbl,R30
; 0000 01A3          if((DOWN_Button)&(trbl > 0)) trbl--;
_0x33:
	RCALL SUBOPT_0x19
	LDS  R26,_trbl
	RCALL SUBOPT_0x1A
	BREQ _0x34
	LDS  R30,_trbl
	SUBI R30,LOW(1)
	STS  _trbl,R30
; 0000 01A4          tda_send(t_adr, t_val[trbl]);
_0x34:
	RCALL SUBOPT_0x3
; 0000 01A5 
; 0000 01A6        fflag = 0;
	RCALL SUBOPT_0x8
; 0000 01A7        timer = 0;
	RCALL SUBOPT_0x7
; 0000 01A8        };
_0x30:
; 0000 01A9        //*****************************************
; 0000 01AA 
; 0000 01AB       //   (bass)
; 0000 01AC        if ((mode==3)&&(fflag==1)) {
	LDI  R30,LOW(3)
	CP   R30,R6
	BRNE _0x36
	SBRC R2,0
	RJMP _0x37
_0x36:
	RJMP _0x35
_0x37:
; 0000 01AD        lcd_clear();
	RCALL _lcd_clear
; 0000 01AE          gotoxy(20,3); print_message("   ");
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
	__POINTW1FN _0x0,24
	RCALL SUBOPT_0x18
; 0000 01AF          //gotoxy(3,6); print_char(bass);
; 0000 01B0          if((UP_Button)&(bass < 14)) bass++;
	LDS  R26,_bass
	LDI  R30,LOW(14)
	RCALL __LTB12U
	AND  R30,R0
	BREQ _0x38
	LDS  R30,_bass
	SUBI R30,-LOW(1)
	STS  _bass,R30
; 0000 01B1          if((DOWN_Button)&(bass > 0)) bass--;
_0x38:
	RCALL SUBOPT_0x19
	LDS  R26,_bass
	RCALL SUBOPT_0x1A
	BREQ _0x39
	LDS  R30,_bass
	SUBI R30,LOW(1)
	STS  _bass,R30
; 0000 01B2          tda_send(b_adr, b_val[bass]);
_0x39:
	RCALL SUBOPT_0x4
; 0000 01B3 
; 0000 01B4        fflag = 0;
	RCALL SUBOPT_0x8
; 0000 01B5        timer = 0;
	RCALL SUBOPT_0x7
; 0000 01B6        };
_0x35:
; 0000 01B7       //*****************************************
; 0000 01B8 
; 0000 01B9       //  (set)
; 0000 01BA        if ((mode==4)&&(fflag==1)) {
	LDI  R30,LOW(4)
	CP   R30,R6
	BRNE _0x3B
	SBRC R2,0
	RJMP _0x3C
_0x3B:
	RJMP _0x3A
_0x3C:
; 0000 01BB        lcd_clear();
	RCALL _lcd_clear
; 0000 01BC          gotoxy(20,2); print_message(" ");
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0xF
	__POINTW1FN _0x0,34
	RCALL SUBOPT_0x9
	RCALL _print_message
; 0000 01BD          gotoxy(25,3); print_message(" ");
	LDI  R30,LOW(25)
	ST   -Y,R30
	RCALL SUBOPT_0x17
	__POINTW1FN _0x0,45
	RCALL SUBOPT_0x9
	RCALL _print_message
; 0000 01BE          gotoxy(30,6); print_message("00 00");
	LDI  R30,LOW(30)
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _gotoxy
	__POINTW1FN _0x0,54
	RCALL SUBOPT_0x9
	RCALL _print_message
; 0000 01BF 
; 0000 01C0        fflag = 0;
	RCALL SUBOPT_0x8
; 0000 01C1        timer = 0;
	RCALL SUBOPT_0x7
; 0000 01C2        };
_0x3A:
; 0000 01C3 
; 0000 01C4 
; 0000 01C5 
; 0000 01C6 
; 0000 01C7      };
	ADIW R28,2
	RJMP _0xB
; 0000 01C8 }
_0x3D:
	RJMP _0x3D

	.CSEG
_lcd_clear:
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x5
	LDI  R30,LOW(64)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	LDI  R30,LOW(176)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	LDI  R30,LOW(16)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x5
	RCALL _lcd_write
	RCALL SUBOPT_0x5
	LDI  R30,LOW(174)
	RCALL SUBOPT_0xE
	__GETWRN 16,17,0
_0x2000004:
	__CPWRN 16,17,864
	BRSH _0x2000005
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x5
	RCALL _lcd_write
	__ADDWRN 16,17,1
	RJMP _0x2000004
_0x2000005:
	RCALL SUBOPT_0x5
	LDI  R30,LOW(175)
	RCALL SUBOPT_0xE
	RCALL __LOADLOCR2P
	RET
_lcd_init:
	ST   -Y,R17
	IN   R30,0x18
	AND  R30,R17
	OUT  0x18,R30
	LDI  R17,LOW(32)
	RCALL SUBOPT_0x1B
	MOV  R30,R17
	RCALL SUBOPT_0x1C
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL SUBOPT_0x13
	LDI  R17,LOW(32)
	IN   R30,0x18
	OR   R30,R17
	OUT  0x18,R30
	RCALL SUBOPT_0x5
	LDI  R30,LOW(32)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	LDI  R30,LOW(159)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	LDI  R30,LOW(164)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	LDI  R30,LOW(47)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	LDI  R30,LOW(64)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	LDI  R30,LOW(176)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	LDI  R30,LOW(16)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x5
	RCALL _lcd_write
	RCALL SUBOPT_0x5
	LDI  R30,LOW(200)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	LDI  R30,LOW(172)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x5
	RCALL _lcd_write
	RCALL SUBOPT_0x5
	LDI  R30,LOW(175)
	RCALL SUBOPT_0xE
	RCALL _lcd_clear
	RCALL SUBOPT_0x5
	LDI  R30,LOW(167)
	RCALL SUBOPT_0xE
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x5
	LDI  R30,LOW(166)
	RCALL SUBOPT_0xE
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x13
	LD   R17,Y+
	RET
_lcd_write:
	RCALL __SAVELOCR2
	LDI  R16,LOW(4)
	RCALL SUBOPT_0x1B
	MOV  R30,R16
	RCALL SUBOPT_0x1C
	LDD  R30,Y+3
	CPI  R30,0
	BREQ _0x2000006
	SBI  0x18,3
	RJMP _0x2000007
_0x2000006:
	LDI  R16,LOW(8)
	RCALL SUBOPT_0x1B
	MOV  R30,R16
	RCALL SUBOPT_0x1C
_0x2000007:
	SBI  0x18,2
	LDI  R17,LOW(0)
_0x2000009:
	CPI  R17,8
	BRSH _0x200000A
	LDI  R16,LOW(4)
	RCALL SUBOPT_0x1B
	MOV  R30,R16
	RCALL SUBOPT_0x1C
	LDI  R16,LOW(8)
	LDD  R30,Y+2
	ANDI R30,LOW(0x80)
	BREQ _0x200000B
	IN   R30,0x18
	OR   R30,R16
	RJMP _0x200003E
_0x200000B:
	RCALL SUBOPT_0x1B
	MOV  R30,R16
	COM  R30
	AND  R30,R26
_0x200003E:
	OUT  0x18,R30
	SBI  0x18,2
	RCALL SUBOPT_0xD
	LSL  R30
	ROL  R31
	STD  Y+2,R30
	__DELAY_USB 27
	SUBI R17,-1
	RJMP _0x2000009
_0x200000A:
	RCALL __LOADLOCR2
	RJMP _0x20C0003
_gotoxy:
	RCALL SUBOPT_0x5
	LDD  R30,Y+1
	ANDI R30,LOW(0xF)
	ORI  R30,LOW(0xB0)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	LDD  R30,Y+2
	ANDI R30,LOW(0xF)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0xD
	RCALL __ASRW4
	ANDI R30,LOW(0x7)
	ANDI R31,HIGH(0x7)
	ORI  R30,0x10
	RJMP _0x20C0001
_print_char:
	RCALL __SAVELOCR2
	__GETWRN 16,17,0
_0x200002A:
	__CPWRN 16,17,5
	BRGE _0x200002B
	RCALL SUBOPT_0xC
	LDD  R30,Y+3
	RCALL SUBOPT_0x1D
	SBIW R30,32
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	RCALL __MULW12U
	SUBI R30,LOW(-_FontLookup*2)
	SBCI R31,HIGH(-_FontLookup*2)
	ADD  R30,R16
	ADC  R31,R17
	LPM  R30,Z
	RCALL SUBOPT_0x1D
	LSL  R30
	ROL  R31
	RCALL SUBOPT_0xE
	__ADDWRN 16,17,1
	RJMP _0x200002A
_0x200002B:
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x5
	RCALL _lcd_write
	RCALL __LOADLOCR2
	ADIW R28,3
	RET
_char_12_16:
	ST   -Y,R17
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _gotoxy
	LDI  R17,LOW(0)
_0x2000030:
	CPI  R17,12
	BRSH _0x2000031
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x1E
	SUBI R17,-1
	RJMP _0x2000030
_0x2000031:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL SUBOPT_0xD
	ADIW R30,1
	ST   -Y,R30
	RCALL _gotoxy
	LDI  R17,LOW(12)
_0x2000033:
	CPI  R17,24
	BRSH _0x2000034
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x1E
	SUBI R17,-1
	RJMP _0x2000033
_0x2000034:
	LDD  R17,Y+0
_0x20C0003:
	ADIW R28,4
	RET
_print_message:
	RCALL SUBOPT_0x5
	LDI  R30,LOW(174)
	RCALL SUBOPT_0xE
_0x2000035:
	LD   R30,Y
	LDD  R31,Y+1
	LPM  R30,Z
	CPI  R30,0
	BREQ _0x2000037
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
	SBIW R30,1
	LPM  R30,Z
	ST   -Y,R30
	RCALL _print_char
	RJMP _0x2000035
_0x2000037:
	RCALL SUBOPT_0x5
	LDI  R30,LOW(175)
_0x20C0001:
	ST   -Y,R30
	RCALL _lcd_write
_0x20C0002:
	ADIW R28,2
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.CSEG

	.CSEG

	.DSEG

	.CSEG

	.DSEG
_vol:
	.BYTE 0x1
_trbl:
	.BYTE 0x1
_bass:
	.BYTE 0x1
_set:
	.BYTE 0x1
_mute:
	.BYTE 0x1
_vol_tmp:
	.BYTE 0x1
_timer:
	.BYTE 0x4
_vl_adr:
	.BYTE 0x1
_vr_adr:
	.BYTE 0x1
_t_adr:
	.BYTE 0x1
_b_adr:
	.BYTE 0x1
_Mode_Change_Enabled:
	.BYTE 0x1
_volum_G000:
	.BYTE 0x14

	.ESEG
_e_vol:
	.BYTE 0x1
_e_bass:
	.BYTE 0x1
_e_trbl:
	.BYTE 0x1
_e_set:
	.BYTE 0x1

	.DSEG
_bitaddr:
	.BYTE 0x1
_p_S1030024:
	.BYTE 0x2
__seed_G105:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	OUT  0x2D,R30
	OUT  0x2C,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	STS  _vol,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x2:
	LDS  R30,_vl_adr
	ST   -Y,R30
	LDS  R30,_vol
	LDI  R31,0
	SUBI R30,LOW(-_v_val*2)
	SBCI R31,HIGH(-_v_val*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _tda_send
	LDS  R30,_vr_adr
	ST   -Y,R30
	LDS  R30,_vol
	LDI  R31,0
	SUBI R30,LOW(-_v_val*2)
	SBCI R31,HIGH(-_v_val*2)
	LPM  R30,Z
	ST   -Y,R30
	RJMP _tda_send

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x3:
	LDS  R30,_t_adr
	ST   -Y,R30
	LDS  R30,_trbl
	LDI  R31,0
	SUBI R30,LOW(-_t_val*2)
	SBCI R31,HIGH(-_t_val*2)
	LPM  R30,Z
	ST   -Y,R30
	RJMP _tda_send

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x4:
	LDS  R30,_b_adr
	ST   -Y,R30
	LDS  R30,_bass
	LDI  R31,0
	SUBI R30,LOW(-_b_val*2)
	SBCI R31,HIGH(-_b_val*2)
	LPM  R30,Z
	ST   -Y,R30
	RJMP _tda_send

;OPTIMIZER ADDED SUBROUTINE, CALLED 32 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6:
	LDS  R26,_timer
	LDS  R27,_timer+1
	LDS  R24,_timer+2
	LDS  R25,_timer+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:30 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(0)
	STS  _timer,R30
	STS  _timer+1,R30
	STS  _timer+2,R30
	STS  _timer+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8:
	CLT
	BLD  R2,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x9:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0xA:
	STS  _mute,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xB:
	LDD  R30,Y+1
	LDI  R31,0
	ADIW R30,5
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xD:
	LDD  R30,Y+2
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 25 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0xE:
	ST   -Y,R30
	RJMP _lcd_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RJMP _gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x10:
	__POINTW1FN _0x0,0
	RCALL SUBOPT_0x9
	RJMP _print_message

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x11:
	LDI  R30,LOW(5)
	ST   -Y,R30
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL SUBOPT_0x9
	RCALL _delay_ms
	LDI  R30,LOW(0)
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x13:
	RCALL SUBOPT_0x9
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x14:
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(20)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x16:
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x17:
	LDI  R30,LOW(3)
	ST   -Y,R30
	RJMP _gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x18:
	RCALL SUBOPT_0x9
	RCALL _print_message
	LDI  R30,0
	SBIS 0x13,2
	LDI  R30,1
	MOV  R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x19:
	LDI  R30,0
	SBIS 0x13,3
	LDI  R30,1
	MOV  R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1A:
	LDI  R30,LOW(0)
	RCALL __GTB12U
	AND  R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1B:
	IN   R30,0x18
	MOV  R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1C:
	COM  R30
	AND  R30,R26
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1D:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x1E:
	LDD  R30,Y+4
	LDI  R26,LOW(24)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_deg12x16*2)
	SBCI R31,HIGH(-_deg12x16*2)
	MOVW R26,R30
	MOV  R30,R17
	RCALL SUBOPT_0x1D
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	RJMP SUBOPT_0xE


	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,7
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,13
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__LTB12U:
	CP   R26,R30
	LDI  R30,1
	BRLO __LTB12U1
	CLR  R30
__LTB12U1:
	RET

__GTB12U:
	CP   R30,R26
	LDI  R30,1
	BRLO __GTB12U1
	CLR  R30
__GTB12U1:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
