/*******************************************************************
 _   _    ___    _  __  ___      _          _   _    ___     ___        _       ____   ____
| \ | |  / _ \  | |/ / |_ _|    / \        / | / |  / _ \   / _ \      | |     / ___| |  _ \
|  \| | | | | | | ' /   | |    / _ \       | | | | | | | | | | | |     | |    | |     | | | |
| |\  | | |_| | | . \   | |   / ___ \      | | | | | |_| | | |_| |     | |___ | |___  | |_| |
|_| \_|  \___/  |_|\_\ |___| /_/   \_\     |_| |_|  \___/   \___/      |_____| \____| |____/

PIC 18f452 to Nokia 1100 LCD Interface
http://sunbizhosting.com/~spiral/

File: main.c
*******************************************************************/

#include <pic18.h> /* Register and bit declarations */ 
#include <string.h>
#include "lcd1100.h"

//--------------------------------------------------------
//	a    PIC18F452 (20)
//--------------------------------------------------------
__CONFIG(1, OSCSEN& HS); 
__CONFIG(2, BOREN & BORV45 & PWRTEN & WDTDIS); 
__CONFIG(3, CCP2RC1); //CCP2  RC1
__CONFIG(4, DEBUGDIS & LVPDIS & STVRDIS); 
__CONFIG(5, UNPROTECT); __CONFIG(6, WRTEN); __CONFIG(7, TRU); //     


typedef unsigned char BYTE; 
//// Constant declarations 
//#define CLOCK 8	//clock in MHz

char p[7];

void init (void);
void long_to_string_lz (unsigned int input, char *str, char numdigits);
void long_to_string (unsigned int input, char *str, char numdigits);
 

///////////////////////////////////////////////////////////////////
void main (void)
{
	init();
	Lcd_Init();
	Gotoxy(0,0);
	//print_message(",.1234567890-=\`qwertyuiop[]asdfghjkl;'zxcvbnm,./");
	//print_message("Hello, world!!  demo of Nokia     1100 LCD ..");
	//Gotoxy(20,5);
    //print_message("It works!!");
    VLine(20,50,1);
    while(1)
    {

    }
}

void init (void)
{
  TRISD = 0b00000010;
}



/*
*********************************************************************************************************
* long_to_string()
*
* Description : Convert a "long" to a null-terminated string
*               (base = decimal)
* Arguments   : input = number to be converted
*               str = pointer to string (i.e. display buffer)
*               numdigits = number of digits to display
* Returns     : none
*********************************************************************************************************
*/
void long_to_string (unsigned int input, char *str, char numdigits)
{
  char digit;
  int blank = 1;
  long_to_string_lz(input, str, numdigits);
  for (digit=0; digit < numdigits-1; digit++) {
    if (str[digit] == '0') {
      if (blank == 1) str[digit] = ' ';
    }
    else {
      blank = 0;
    }
  }
}


/*
*********************************************************************************************************
* long_to_string_lz()
*
* Description : Convert a "long" to a null-terminated string, with leading zeros
*               (base = decimal)
* Arguments   : input = number to be converted
*               str = pointer to string (i.e. display buffer)
*               numdigits = number of digits to display
* Returns     : none
*********************************************************************************************************
*/
void long_to_string_lz (unsigned int input, char *str, char numdigits)
{
  char digit;
  for (digit=numdigits; digit > 0; digit--) {
    str[digit-1] = (input % 10) + '0';
    input = input / 10;
  }
  str[numdigits] = 0;    // null-terminate the string
}
