
;CodeVisionAVR C Compiler V2.03.9 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega88
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega88
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E
	.EQU GPIOR1=0x2A
	.EQU GPIOR2=0x2B

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _l=R3
	.DEF _i=R2
	.DEF _j=R5
	.DEF _n=R4
	.DEF _t=R7
	.DEF _s=R6
	.DEF _w=R8

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;GPIOR0-GPIOR2 INITIALIZATION
	.EQU  __GPIOR0_INIT=0x00
	.EQU  __GPIOR1_INIT=0x00
	.EQU  __GPIOR2_INIT=0x00

_0x0:
	.DB  0x49,0x20,0x57,0x6F,0x72,0x6B,0x2E,0x2E
	.DB  0x2E,0x0,0x50,0x52,0x45,0x53,0x53,0x20
	.DB  0x4F,0x4B,0x0
__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x4FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x4FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x200)
	LDI  R29,HIGH(0x200)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x200

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V1.24.4 Standard
;Automatic Program Generator
; Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;e-mail:office@hpinfotech.com
;
;Project :
;Version :
;Date    : 21.12.2008
;Author  : Admin
;Company : Microsoft
;Comments:
;
;
;Chip type           : ATmega88
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;External SRAM size  : 0
;Data Stack size     : 256
;*****************************************************/
;
;eeprom struct rom {
;            char Font[5];}
;            FontH[96]={
;{0x00, 0x00, 0x00, 0x00, 0x00},// (space)
;{0x00, 0x00, 0x5F, 0x00, 0x00},// !
;{0x00, 0x07, 0x00, 0x07, 0x00},// "
;{0x14, 0x7F, 0x14, 0x7F, 0x14},// #
;{0x24, 0x2A, 0x7F, 0x2A, 0x12},// $
;{0x23, 0x13, 0x08, 0x64, 0x62},// %
;{0x36, 0x49, 0x55, 0x22, 0x50},// &
;{0x00, 0x05, 0x03, 0x00, 0x00},// '
;{0x00, 0x1C, 0x22, 0x41, 0x00},// (
;{0x00, 0x41, 0x22, 0x1C, 0x00},// )
;{0x08, 0x2A, 0x1C, 0x2A, 0x08},// *
;{0x08, 0x08, 0x3E, 0x08, 0x08},// +
;{0x00, 0x50, 0x30, 0x00, 0x00},// ,
;{0x08, 0x08, 0x08, 0x08, 0x08},// -
;{0x00, 0x30, 0x30, 0x00, 0x00},// .
;{0x20, 0x10, 0x08, 0x04, 0x02},// /
;{0x3E, 0x51, 0x49, 0x45, 0x3E},// 0
;{0x00, 0x42, 0x7F, 0x40, 0x00},// 1
;{0x42, 0x61, 0x51, 0x49, 0x46},// 2
;{0x21, 0x41, 0x45, 0x4B, 0x31},// 3
;{0x18, 0x14, 0x12, 0x7F, 0x10},// 4
;{0x27, 0x45, 0x45, 0x45, 0x39},// 5
;{0x3C, 0x4A, 0x49, 0x49, 0x30},// 6
;{0x01, 0x71, 0x09, 0x05, 0x03},// 7
;{0x36, 0x49, 0x49, 0x49, 0x36},// 8
;{0x06, 0x49, 0x49, 0x29, 0x1E},// 9
;{0x00, 0x36, 0x36, 0x00, 0x00},// :
;{0x00, 0x56, 0x36, 0x00, 0x00},// ;
;{0x00, 0x08, 0x14, 0x22, 0x41},// <
;{0x14, 0x14, 0x14, 0x14, 0x14},// =
;{0x41, 0x22, 0x14, 0x08, 0x00},// >
;{0x02, 0x01, 0x51, 0x09, 0x06},// ?
;{0x32, 0x49, 0x79, 0x41, 0x3E},// @
;{0x7E, 0x11, 0x11, 0x11, 0x7E},// A
;{0x7F, 0x49, 0x49, 0x49, 0x36},// B
;{0x3E, 0x41, 0x41, 0x41, 0x22},// C
;{0x7F, 0x41, 0x41, 0x22, 0x1C},// D
;{0x7F, 0x49, 0x49, 0x49, 0x41},// E
;{0x7F, 0x09, 0x09, 0x01, 0x01},// F
;{0x3E, 0x41, 0x41, 0x51, 0x32},// G
;{0x7F, 0x08, 0x08, 0x08, 0x7F},// H
;{0x00, 0x41, 0x7F, 0x41, 0x00},// I
;{0x20, 0x40, 0x41, 0x3F, 0x01},// J
;{0x7F, 0x08, 0x14, 0x22, 0x41},// K
;{0x7F, 0x40, 0x40, 0x40, 0x40},// L
;{0x7F, 0x02, 0x04, 0x02, 0x7F},// M
;{0x7F, 0x04, 0x08, 0x10, 0x7F},// N
;{0x3E, 0x41, 0x41, 0x41, 0x3E},// O
;{0x7F, 0x09, 0x09, 0x09, 0x06},// P
;{0x3E, 0x41, 0x51, 0x21, 0x5E},// Q
;{0x7F, 0x09, 0x19, 0x29, 0x46},// R
;{0x46, 0x49, 0x49, 0x49, 0x31},// S
;{0x01, 0x01, 0x7F, 0x01, 0x01},// T
;{0x3F, 0x40, 0x40, 0x40, 0x3F},// U
;{0x1F, 0x20, 0x40, 0x20, 0x1F},// V
;{0x7F, 0x20, 0x18, 0x20, 0x7F},// W
;{0x63, 0x14, 0x08, 0x14, 0x63},// X
;{0x03, 0x04, 0x78, 0x04, 0x03},// Y
;{0x61, 0x51, 0x49, 0x45, 0x43},// Z
;{0x00, 0x00, 0x7F, 0x41, 0x41},// [
;{0x02, 0x04, 0x08, 0x10, 0x20},// "\"
;{0x41, 0x41, 0x7F, 0x00, 0x00},// ]
;{0x04, 0x02, 0x01, 0x02, 0x04},// ^
;{0x40, 0x40, 0x40, 0x40, 0x40},// _
;{0x00, 0x01, 0x02, 0x04, 0x00},// `
;{0x20, 0x54, 0x54, 0x54, 0x78},// a
;{0x7F, 0x48, 0x44, 0x44, 0x38},// b
;{0x38, 0x44, 0x44, 0x44, 0x20},// c
;{0x38, 0x44, 0x44, 0x48, 0x7F},// d
;{0x38, 0x54, 0x54, 0x54, 0x18},// e
;{0x08, 0x7E, 0x09, 0x01, 0x02},// f
;{0x08, 0x14, 0x54, 0x54, 0x3C},// g
;{0x7F, 0x08, 0x04, 0x04, 0x78},// h
;{0x00, 0x44, 0x7D, 0x40, 0x00},// i
;{0x20, 0x40, 0x44, 0x3D, 0x00},// j
;{0x00, 0x7F, 0x10, 0x28, 0x44},// k
;{0x00, 0x41, 0x7F, 0x40, 0x00},// l
;{0x7C, 0x04, 0x18, 0x04, 0x78},// m
;{0x7C, 0x08, 0x04, 0x04, 0x78},// n
;{0x38, 0x44, 0x44, 0x44, 0x38},// o
;{0x7C, 0x14, 0x14, 0x14, 0x08},// p
;{0x08, 0x14, 0x14, 0x18, 0x7C},// q
;{0x7C, 0x08, 0x04, 0x04, 0x08},// r
;{0x48, 0x54, 0x54, 0x54, 0x20},// s
;{0x04, 0x3F, 0x44, 0x40, 0x20},// t
;{0x3C, 0x40, 0x40, 0x20, 0x7C},// u
;{0x1C, 0x20, 0x40, 0x20, 0x1C},// v
;{0x3C, 0x40, 0x30, 0x40, 0x3C},// w
;{0x44, 0x28, 0x10, 0x28, 0x44},// x
;{0x0C, 0x50, 0x50, 0x50, 0x3C},// y
;{0x44, 0x64, 0x54, 0x4C, 0x44},// z
;{0x00, 0x08, 0x36, 0x41, 0x00},// {
;{0x00, 0x00, 0x7F, 0x00, 0x00},// |
;{0x00, 0x41, 0x36, 0x08, 0x00},// }
;{0x08, 0x08, 0x2A, 0x1C, 0x08},// ->
;{0x08, 0x1C, 0x2A, 0x08, 0x08} // <-
;};
;
;#include <mega88.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.SET power_ctrl_reg=smcr
	#endif
;#include <delay.h>
;#include <string.h>
;#include <stdio.h>
;
;#define RXB8 1
;#define TXB8 0
;#define UPE 2
;#define OVR 3
;#define FE 4
;#define UDRE 5
;#define RXC 7
;
;#define cs0   PORTC.1=0;
;#define cs1   PORTC.1=1;
;
;#define sda0 	PORTC.2=0;
;#define sda1 	PORTC.2=1;
;
;#define rst0 	PORTC.0=0;
;#define rst1 	PORTC.0=1;
;
;#define sclk0 	PORTC.3=0;
;#define sclk1 	PORTC.3=1;
;
;
;#define LcdLed0   PORTC.4=0;
;#define LcdLed1   PORTC.4=1;
;
;#define Led0 	PORTC.5=0;
;#define Led1 	PORTC.5=1;
;
;#define byte unsigned char
;
;void init (void);
;void Lcd_Init(void);
;void Lcd_Clear(void);
;void Gotoxy(char x,char y);
;void Lcd_WriteCMD(byte data);
;void Lcd_WriteData(byte data);
;void print_char(char c);
;void print_message(flash char* message);
;void shiftBits(byte b);
;void clear(void);
;unsigned char l;
;byte i, j, n, t, s;
;int w;
;
;
;// Declare your global variables here
;
;void main (void) {
; 0000 00B1 void main (void) {

	.CSEG
_main:
; 0000 00B2 
; 0000 00B3 	init();
	RCALL _init
; 0000 00B4 
; 0000 00B5 	cs1;
	SBI  0x8,1
; 0000 00B6 
; 0000 00B7 	Lcd_Init();
	RCALL _Lcd_Init
; 0000 00B8 
; 0000 00B9 	w = 0;
	CLR  R8
	CLR  R9
; 0000 00BA 
; 0000 00BB 
; 0000 00BC                    Gotoxy(1, 0x01); print_char('S');
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x0
	RCALL _Gotoxy
	LDI  R30,LOW(83)
	RCALL SUBOPT_0x1
; 0000 00BD                    Gotoxy(7, 0x01); print_char('t');
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL SUBOPT_0x0
	RCALL _Gotoxy
	LDI  R30,LOW(116)
	RCALL SUBOPT_0x1
; 0000 00BE                    Gotoxy(13, 0x01); print_char('-');
	LDI  R30,LOW(13)
	ST   -Y,R30
	RCALL SUBOPT_0x0
	RCALL _Gotoxy
	LDI  R30,LOW(45)
	RCALL SUBOPT_0x1
; 0000 00BF                    Gotoxy(19, 0x01); print_char('5');
	LDI  R30,LOW(19)
	ST   -Y,R30
	RCALL SUBOPT_0x0
	RCALL _Gotoxy
	LDI  R30,LOW(53)
	RCALL SUBOPT_0x1
; 0000 00C0 
; 0000 00C1                    Gotoxy(1, 4);
	RCALL SUBOPT_0x0
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _Gotoxy
; 0000 00C2                    print_message("I Work...");
	__POINTW1FN _0x0,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print_message
; 0000 00C3                    Gotoxy(25, 7);
	LDI  R30,LOW(25)
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _Gotoxy
; 0000 00C4                    print_message("PRESS OK");
	__POINTW1FN _0x0,10
	RCALL SUBOPT_0x2
	RCALL _print_message
; 0000 00C5 
; 0000 00C6 while(1)
_0x5:
; 0000 00C7    {
; 0000 00C8 
; 0000 00C9 
; 0000 00CA     }
	RJMP _0x5
; 0000 00CB }
_0x8:
	RJMP _0x8
;
;void Lcd_Clear(void){
; 0000 00CD void Lcd_Clear(void){
_Lcd_Clear:
; 0000 00CE unsigned int i;
; 0000 00CF Lcd_WriteCMD(0x40); // Y = 0
	RCALL __SAVELOCR2
;	i -> R16,R17
	RCALL SUBOPT_0x3
; 0000 00D0 Lcd_WriteCMD(0xb0);
; 0000 00D1 Lcd_WriteCMD(0x10); // X = 0
; 0000 00D2 Lcd_WriteCMD(0x0);
; 0000 00D3 Lcd_WriteCMD(0xae); // disable display;
	LDI  R30,LOW(174)
	RCALL SUBOPT_0x4
; 0000 00D4 for(i=0;i<864;i++)
	__GETWRN 16,17,0
_0xA:
	__CPWRN 16,17,864
	BRSH _0xB
; 0000 00D5 Lcd_WriteData(0x00);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _Lcd_WriteData
	__ADDWRN 16,17,1
	RJMP _0xA
_0xB:
; 0000 00D6 Lcd_WriteCMD(0xaf);
	LDI  R30,LOW(175)
	RCALL SUBOPT_0x4
; 0000 00D7 }
	RCALL __LOADLOCR2P
	RET
;
;// init LCD
;void Lcd_Init(void){
; 0000 00DA void Lcd_Init(void){
_Lcd_Init:
; 0000 00DB 
; 0000 00DC cs0;
	CBI  0x8,1
; 0000 00DD rst0 ;
	CBI  0x8,0
; 0000 00DE  delay_ms(1);			// 5mS so says the stop watch(less than 5ms will not work)
	RCALL SUBOPT_0x5
; 0000 00DF rst1 ;
	SBI  0x8,0
; 0000 00E0 Lcd_WriteCMD(0x20); // write VOP register
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x4
; 0000 00E1 Lcd_WriteCMD(0x90);
	LDI  R30,LOW(144)
	RCALL SUBOPT_0x4
; 0000 00E2 Lcd_WriteCMD(0xA4); // all on/normal display
	LDI  R30,LOW(164)
	RCALL SUBOPT_0x4
; 0000 00E3 Lcd_WriteCMD(0x2F); // Power control set(charge pump on/off)
	LDI  R30,LOW(47)
	RCALL SUBOPT_0x4
; 0000 00E4 Lcd_WriteCMD(0x40); // set start row address = 0
	RCALL SUBOPT_0x3
; 0000 00E5 Lcd_WriteCMD(0xb0); // set Y-address = 0
; 0000 00E6 Lcd_WriteCMD(0x10); // set X-address, upper 3 bits
; 0000 00E7 Lcd_WriteCMD(0x0);  // set X-address, lower 4 bits
; 0000 00E8 Lcd_WriteCMD(0xC8); // mirror Y axis (about X axis)
	LDI  R30,LOW(200)
	RCALL SUBOPT_0x4
; 0000 00E9 Lcd_WriteCMD(0xa1); // Invert screen in horizontal axis
	LDI  R30,LOW(161)
	RCALL SUBOPT_0x4
; 0000 00EA Lcd_WriteCMD(0xac); // set initial row (R0) of the display
	LDI  R30,LOW(172)
	RCALL SUBOPT_0x4
; 0000 00EB Lcd_WriteCMD(0x07);
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x4
; 0000 00EC Lcd_WriteCMD(0xaf); // display ON/OFF
	LDI  R30,LOW(175)
	RCALL SUBOPT_0x4
; 0000 00ED Lcd_Clear(); // clear LCD
	RCALL _Lcd_Clear
; 0000 00EE Lcd_WriteCMD(0xa7); // invert display
	LDI  R30,LOW(167)
	RCALL SUBOPT_0x4
; 0000 00EF  delay_ms(1);// 1/2 Sec delay
	RCALL SUBOPT_0x5
; 0000 00F0 Lcd_WriteCMD(0xa6); // normal display (non inverted)
	LDI  R30,LOW(166)
	RCALL SUBOPT_0x4
; 0000 00F1  delay_ms(2);				// 1 Sec delay
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL SUBOPT_0x2
	RCALL _delay_ms
; 0000 00F2 }
	RET
;
;void Lcd_WriteCMD(byte data)
; 0000 00F5 {
_Lcd_WriteCMD:
; 0000 00F6         cs0 ;
;	data -> Y+0
	CBI  0x8,1
; 0000 00F7 	sclk0;
	CBI  0x8,3
; 0000 00F8 	sda0;
	CBI  0x8,2
; 0000 00F9 	sclk1;
	RCALL SUBOPT_0x6
; 0000 00FA         shiftBits(data);
; 0000 00FB 	cs1;
; 0000 00FC }
	RJMP _0x2060002
;
;void Lcd_WriteData(byte data)
; 0000 00FF {
_Lcd_WriteData:
; 0000 0100 
; 0000 0101         cs0;
;	data -> Y+0
	CBI  0x8,1
; 0000 0102         sclk0;
	CBI  0x8,3
; 0000 0103 	sda1;
	SBI  0x8,2
; 0000 0104 	sclk1;
	RCALL SUBOPT_0x6
; 0000 0105         shiftBits(data);
; 0000 0106 	cs1;
; 0000 0107 }
	RJMP _0x2060002
;
;void shiftBits(byte b)
; 0000 010A {
_shiftBits:
; 0000 010B 
; 0000 010C 	sclk0;
;	b -> Y+0
	RCALL SUBOPT_0x7
; 0000 010D 	if ((b&128)!=0) sda1 else sda0;
	ANDI R30,LOW(0x80)
	BREQ _0x28
	SBI  0x8,2
	RJMP _0x2B
_0x28:
	CBI  0x8,2
; 0000 010E 	sclk1;
_0x2B:
	RCALL SUBOPT_0x8
; 0000 010F 
; 0000 0110 	sclk0;
; 0000 0111 	if ((b&64)!=0) sda1 else sda0;
	ANDI R30,LOW(0x40)
	BREQ _0x32
	SBI  0x8,2
	RJMP _0x35
_0x32:
	CBI  0x8,2
; 0000 0112 	sclk1;
_0x35:
	RCALL SUBOPT_0x8
; 0000 0113 
; 0000 0114 	sclk0;
; 0000 0115 	if ((b&32)!=0) sda1 else sda0;
	ANDI R30,LOW(0x20)
	BREQ _0x3C
	SBI  0x8,2
	RJMP _0x3F
_0x3C:
	CBI  0x8,2
; 0000 0116 	sclk1;
_0x3F:
	RCALL SUBOPT_0x8
; 0000 0117 
; 0000 0118 	sclk0;
; 0000 0119 	if ((b&16)!=0) sda1 else sda0;
	ANDI R30,LOW(0x10)
	BREQ _0x46
	SBI  0x8,2
	RJMP _0x49
_0x46:
	CBI  0x8,2
; 0000 011A 	sclk1;
_0x49:
	RCALL SUBOPT_0x8
; 0000 011B 
; 0000 011C 	sclk0;
; 0000 011D 	if ((b&8)!=0) sda1 else sda0;
	ANDI R30,LOW(0x8)
	BREQ _0x50
	SBI  0x8,2
	RJMP _0x53
_0x50:
	CBI  0x8,2
; 0000 011E 	sclk1;
_0x53:
	RCALL SUBOPT_0x8
; 0000 011F 
; 0000 0120 	sclk0;
; 0000 0121 	if ((b&4)!=0) sda1 else sda0;
	ANDI R30,LOW(0x4)
	BREQ _0x5A
	SBI  0x8,2
	RJMP _0x5D
_0x5A:
	CBI  0x8,2
; 0000 0122 	sclk1;
_0x5D:
	RCALL SUBOPT_0x8
; 0000 0123 
; 0000 0124 	sclk0;
; 0000 0125 	if ((b&2)!=0) sda1 else sda0;
	ANDI R30,LOW(0x2)
	BREQ _0x64
	SBI  0x8,2
	RJMP _0x67
_0x64:
	CBI  0x8,2
; 0000 0126 	sclk1;
_0x67:
	RCALL SUBOPT_0x8
; 0000 0127 
; 0000 0128 	sclk0;
; 0000 0129 	if ((b&1)!=0) sda1 else sda0;
	ANDI R30,LOW(0x1)
	BREQ _0x6E
	SBI  0x8,2
	RJMP _0x71
_0x6E:
	CBI  0x8,2
; 0000 012A 	sclk1;
_0x71:
	SBI  0x8,3
; 0000 012B 
; 0000 012C 	 delay_us(2);
	__DELAY_USB 5
; 0000 012D 
; 0000 012E 	 sclk0;
	CBI  0x8,3
; 0000 012F 
; 0000 0130 }
_0x2060002:
	ADIW R28,1
	RET
;
;
;void Gotoxy(char x,char y){
; 0000 0133 void Gotoxy(char x,char y){
_Gotoxy:
; 0000 0134 		Lcd_WriteCMD((0xB0|(y&0x0F)));		 // Y axis initialisation: 0100 yyyy
;	x -> Y+1
;	y -> Y+0
	LD   R30,Y
	ANDI R30,LOW(0xF)
	ORI  R30,LOW(0xB0)
	RCALL SUBOPT_0x4
; 0000 0135 		Lcd_WriteCMD((0x00|(x&0x0F)));		 // X axis initialisation: 0000 xxxx ( x3 x2 x1 x0)
	LDD  R30,Y+1
	ANDI R30,LOW(0xF)
	RCALL SUBOPT_0x4
; 0000 0136 		Lcd_WriteCMD((0x10|((x>>4)&0x07)));      // X axis initialisation: 0010 0xxx  ( x6 x5 x4)
	LDD  R30,Y+1
	SWAP R30
	ANDI R30,LOW(0x7)
	ORI  R30,0x10
	RJMP _0x2060001
; 0000 0137 
; 0000 0138 }
;
;
;void print_char(char c)
; 0000 013C     {
_print_char:
; 0000 013D 	int i;
; 0000 013E         	for ( i = 0; i < 5; i++ ){
	RCALL __SAVELOCR2
;	c -> Y+2
;	i -> R16,R17
	__GETWRN 16,17,0
_0x79:
	__CPWRN 16,17,5
	BRGE _0x7A
; 0000 013F 			 Lcd_WriteData(FontH[c - 32].Font[i] << 1);
	LDD  R30,Y+2
	SUBI R30,LOW(32)
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_FontH)
	SBCI R31,HIGH(-_FontH)
	ADD  R30,R16
	ADC  R31,R17
	MOVW R26,R30
	RCALL __EEPROMRDB
	LSL  R30
	ST   -Y,R30
	RCALL _Lcd_WriteData
; 0000 0140         }
	__ADDWRN 16,17,1
	RJMP _0x79
_0x7A:
; 0000 0141 			Lcd_WriteData(0x00);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _Lcd_WriteData
; 0000 0142 
; 0000 0143     }
	RCALL __LOADLOCR2
	ADIW R28,3
	RET
;
;void print_message(flash char * message)  // Write message to LCD (C string type)
; 0000 0146    {
_print_message:
; 0000 0147          Lcd_WriteCMD(0xae); // disable display;
;	*message -> Y+0
	LDI  R30,LOW(174)
	RCALL SUBOPT_0x4
; 0000 0148 		while (*message){			// Look for end of string
_0x7B:
	LD   R30,Y
	LDD  R31,Y+1
	LPM  R30,Z
	CPI  R30,0
	BREQ _0x7D
; 0000 0149 				  print_char(*message++);
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
	SBIW R30,1
	LPM  R30,Z
	RCALL SUBOPT_0x1
; 0000 014A 				}
	RJMP _0x7B
_0x7D:
; 0000 014B 	 Lcd_WriteCMD(0xaf); // enable display;
	LDI  R30,LOW(175)
_0x2060001:
	ST   -Y,R30
	RCALL _Lcd_WriteCMD
; 0000 014C    }
	ADIW R28,2
	RET
;
;void init(void)
; 0000 014F {
_init:
; 0000 0150 // Declare your local variables here
; 0000 0151 
; 0000 0152 // Crystal Oscillator division factor: 1
; 0000 0153 CLKPR=0x80;
	LDI  R30,LOW(128)
	STS  97,R30
; 0000 0154 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
; 0000 0155 
; 0000 0156 // Input/Output Ports initialization
; 0000 0157 // Port B initialization
; 0000 0158 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0159 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 015A PORTB=0x00;
	OUT  0x5,R30
; 0000 015B DDRB=0x00;
	OUT  0x4,R30
; 0000 015C 
; 0000 015D // Port C initialization
; 0000 015E // Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 015F // State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 0160 PORTC=0x00;
	OUT  0x8,R30
; 0000 0161 DDRC=0x7F;
	LDI  R30,LOW(127)
	OUT  0x7,R30
; 0000 0162 
; 0000 0163 // Port D initialization
; 0000 0164 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0165 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0166 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
; 0000 0167 DDRD=0x00;
	OUT  0xA,R30
; 0000 0168 
; 0000 0169 #asm("sei")
	sei
; 0000 016A }
	RET

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.SET power_ctrl_reg=smcr
	#endif

	.CSEG

	.CSEG

	.ESEG
_FontH:
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x5F000000),HIGH(0x5F000000),BYTE3(0x5F000000),BYTE4(0x5F000000)
	.DB  LOW(0x7000000),HIGH(0x7000000),BYTE3(0x7000000),BYTE4(0x7000000)
	.DB  LOW(0x14000700),HIGH(0x14000700),BYTE3(0x14000700),BYTE4(0x14000700)
	.DB  LOW(0x147F147F),HIGH(0x147F147F),BYTE3(0x147F147F),BYTE4(0x147F147F)
	.DB  LOW(0x2A7F2A24),HIGH(0x2A7F2A24),BYTE3(0x2A7F2A24),BYTE4(0x2A7F2A24)
	.DB  LOW(0x8132312),HIGH(0x8132312),BYTE3(0x8132312),BYTE4(0x8132312)
	.DB  LOW(0x49366264),HIGH(0x49366264),BYTE3(0x49366264),BYTE4(0x49366264)
	.DB  LOW(0x502255),HIGH(0x502255),BYTE3(0x502255),BYTE4(0x502255)
	.DB  LOW(0x305),HIGH(0x305),BYTE3(0x305),BYTE4(0x305)
	.DB  LOW(0x41221C00),HIGH(0x41221C00),BYTE3(0x41221C00),BYTE4(0x41221C00)
	.DB  LOW(0x22410000),HIGH(0x22410000),BYTE3(0x22410000),BYTE4(0x22410000)
	.DB  LOW(0x2A08001C),HIGH(0x2A08001C),BYTE3(0x2A08001C),BYTE4(0x2A08001C)
	.DB  LOW(0x8082A1C),HIGH(0x8082A1C),BYTE3(0x8082A1C),BYTE4(0x8082A1C)
	.DB  LOW(0x8083E08),HIGH(0x8083E08),BYTE3(0x8083E08),BYTE4(0x8083E08)
	.DB  LOW(0x305000),HIGH(0x305000),BYTE3(0x305000),BYTE4(0x305000)
	.DB  LOW(0x8080800),HIGH(0x8080800),BYTE3(0x8080800),BYTE4(0x8080800)
	.DB  LOW(0x30000808),HIGH(0x30000808),BYTE3(0x30000808),BYTE4(0x30000808)
	.DB  LOW(0x20000030),HIGH(0x20000030),BYTE3(0x20000030),BYTE4(0x20000030)
	.DB  LOW(0x2040810),HIGH(0x2040810),BYTE3(0x2040810),BYTE4(0x2040810)
	.DB  LOW(0x4549513E),HIGH(0x4549513E),BYTE3(0x4549513E),BYTE4(0x4549513E)
	.DB  LOW(0x7F42003E),HIGH(0x7F42003E),BYTE3(0x7F42003E),BYTE4(0x7F42003E)
	.DB  LOW(0x61420040),HIGH(0x61420040),BYTE3(0x61420040),BYTE4(0x61420040)
	.DB  LOW(0x21464951),HIGH(0x21464951),BYTE3(0x21464951),BYTE4(0x21464951)
	.DB  LOW(0x314B4541),HIGH(0x314B4541),BYTE3(0x314B4541),BYTE4(0x314B4541)
	.DB  LOW(0x7F121418),HIGH(0x7F121418),BYTE3(0x7F121418),BYTE4(0x7F121418)
	.DB  LOW(0x45452710),HIGH(0x45452710),BYTE3(0x45452710),BYTE4(0x45452710)
	.DB  LOW(0x4A3C3945),HIGH(0x4A3C3945),BYTE3(0x4A3C3945),BYTE4(0x4A3C3945)
	.DB  LOW(0x1304949),HIGH(0x1304949),BYTE3(0x1304949),BYTE4(0x1304949)
	.DB  LOW(0x3050971),HIGH(0x3050971),BYTE3(0x3050971),BYTE4(0x3050971)
	.DB  LOW(0x49494936),HIGH(0x49494936),BYTE3(0x49494936),BYTE4(0x49494936)
	.DB  LOW(0x49490636),HIGH(0x49490636),BYTE3(0x49490636),BYTE4(0x49490636)
	.DB  LOW(0x36001E29),HIGH(0x36001E29),BYTE3(0x36001E29),BYTE4(0x36001E29)
	.DB  LOW(0x36),HIGH(0x36),BYTE3(0x36),BYTE4(0x36)
	.DB  LOW(0x3656),HIGH(0x3656),BYTE3(0x3656),BYTE4(0x3656)
	.DB  LOW(0x22140800),HIGH(0x22140800),BYTE3(0x22140800),BYTE4(0x22140800)
	.DB  LOW(0x14141441),HIGH(0x14141441),BYTE3(0x14141441),BYTE4(0x14141441)
	.DB  LOW(0x22411414),HIGH(0x22411414),BYTE3(0x22411414),BYTE4(0x22411414)
	.DB  LOW(0x2000814),HIGH(0x2000814),BYTE3(0x2000814),BYTE4(0x2000814)
	.DB  LOW(0x6095101),HIGH(0x6095101),BYTE3(0x6095101),BYTE4(0x6095101)
	.DB  LOW(0x41794932),HIGH(0x41794932),BYTE3(0x41794932),BYTE4(0x41794932)
	.DB  LOW(0x11117E3E),HIGH(0x11117E3E),BYTE3(0x11117E3E),BYTE4(0x11117E3E)
	.DB  LOW(0x497F7E11),HIGH(0x497F7E11),BYTE3(0x497F7E11),BYTE4(0x497F7E11)
	.DB  LOW(0x3E364949),HIGH(0x3E364949),BYTE3(0x3E364949),BYTE4(0x3E364949)
	.DB  LOW(0x22414141),HIGH(0x22414141),BYTE3(0x22414141),BYTE4(0x22414141)
	.DB  LOW(0x2241417F),HIGH(0x2241417F),BYTE3(0x2241417F),BYTE4(0x2241417F)
	.DB  LOW(0x49497F1C),HIGH(0x49497F1C),BYTE3(0x49497F1C),BYTE4(0x49497F1C)
	.DB  LOW(0x97F4149),HIGH(0x97F4149),BYTE3(0x97F4149),BYTE4(0x97F4149)
	.DB  LOW(0x3E010109),HIGH(0x3E010109),BYTE3(0x3E010109),BYTE4(0x3E010109)
	.DB  LOW(0x32514141),HIGH(0x32514141),BYTE3(0x32514141),BYTE4(0x32514141)
	.DB  LOW(0x808087F),HIGH(0x808087F),BYTE3(0x808087F),BYTE4(0x808087F)
	.DB  LOW(0x7F41007F),HIGH(0x7F41007F),BYTE3(0x7F41007F),BYTE4(0x7F41007F)
	.DB  LOW(0x40200041),HIGH(0x40200041),BYTE3(0x40200041),BYTE4(0x40200041)
	.DB  LOW(0x7F013F41),HIGH(0x7F013F41),BYTE3(0x7F013F41),BYTE4(0x7F013F41)
	.DB  LOW(0x41221408),HIGH(0x41221408),BYTE3(0x41221408),BYTE4(0x41221408)
	.DB  LOW(0x4040407F),HIGH(0x4040407F),BYTE3(0x4040407F),BYTE4(0x4040407F)
	.DB  LOW(0x4027F40),HIGH(0x4027F40),BYTE3(0x4027F40),BYTE4(0x4027F40)
	.DB  LOW(0x47F7F02),HIGH(0x47F7F02),BYTE3(0x47F7F02),BYTE4(0x47F7F02)
	.DB  LOW(0x3E7F1008),HIGH(0x3E7F1008),BYTE3(0x3E7F1008),BYTE4(0x3E7F1008)
	.DB  LOW(0x3E414141),HIGH(0x3E414141),BYTE3(0x3E414141),BYTE4(0x3E414141)
	.DB  LOW(0x909097F),HIGH(0x909097F),BYTE3(0x909097F),BYTE4(0x909097F)
	.DB  LOW(0x51413E06),HIGH(0x51413E06),BYTE3(0x51413E06),BYTE4(0x51413E06)
	.DB  LOW(0x97F5E21),HIGH(0x97F5E21),BYTE3(0x97F5E21),BYTE4(0x97F5E21)
	.DB  LOW(0x46462919),HIGH(0x46462919),BYTE3(0x46462919),BYTE4(0x46462919)
	.DB  LOW(0x31494949),HIGH(0x31494949),BYTE3(0x31494949),BYTE4(0x31494949)
	.DB  LOW(0x17F0101),HIGH(0x17F0101),BYTE3(0x17F0101),BYTE4(0x17F0101)
	.DB  LOW(0x40403F01),HIGH(0x40403F01),BYTE3(0x40403F01),BYTE4(0x40403F01)
	.DB  LOW(0x201F3F40),HIGH(0x201F3F40),BYTE3(0x201F3F40),BYTE4(0x201F3F40)
	.DB  LOW(0x7F1F2040),HIGH(0x7F1F2040),BYTE3(0x7F1F2040),BYTE4(0x7F1F2040)
	.DB  LOW(0x7F201820),HIGH(0x7F201820),BYTE3(0x7F201820),BYTE4(0x7F201820)
	.DB  LOW(0x14081463),HIGH(0x14081463),BYTE3(0x14081463),BYTE4(0x14081463)
	.DB  LOW(0x78040363),HIGH(0x78040363),BYTE3(0x78040363),BYTE4(0x78040363)
	.DB  LOW(0x51610304),HIGH(0x51610304),BYTE3(0x51610304),BYTE4(0x51610304)
	.DB  LOW(0x434549),HIGH(0x434549),BYTE3(0x434549),BYTE4(0x434549)
	.DB  LOW(0x41417F00),HIGH(0x41417F00),BYTE3(0x41417F00),BYTE4(0x41417F00)
	.DB  LOW(0x10080402),HIGH(0x10080402),BYTE3(0x10080402),BYTE4(0x10080402)
	.DB  LOW(0x7F414120),HIGH(0x7F414120),BYTE3(0x7F414120),BYTE4(0x7F414120)
	.DB  LOW(0x2040000),HIGH(0x2040000),BYTE3(0x2040000),BYTE4(0x2040000)
	.DB  LOW(0x40040201),HIGH(0x40040201),BYTE3(0x40040201),BYTE4(0x40040201)
	.DB  LOW(0x40404040),HIGH(0x40404040),BYTE3(0x40404040),BYTE4(0x40404040)
	.DB  LOW(0x4020100),HIGH(0x4020100),BYTE3(0x4020100),BYTE4(0x4020100)
	.DB  LOW(0x54542000),HIGH(0x54542000),BYTE3(0x54542000),BYTE4(0x54542000)
	.DB  LOW(0x487F7854),HIGH(0x487F7854),BYTE3(0x487F7854),BYTE4(0x487F7854)
	.DB  LOW(0x38384444),HIGH(0x38384444),BYTE3(0x38384444),BYTE4(0x38384444)
	.DB  LOW(0x20444444),HIGH(0x20444444),BYTE3(0x20444444),BYTE4(0x20444444)
	.DB  LOW(0x48444438),HIGH(0x48444438),BYTE3(0x48444438),BYTE4(0x48444438)
	.DB  LOW(0x5454387F),HIGH(0x5454387F),BYTE3(0x5454387F),BYTE4(0x5454387F)
	.DB  LOW(0x7E081854),HIGH(0x7E081854),BYTE3(0x7E081854),BYTE4(0x7E081854)
	.DB  LOW(0x8020109),HIGH(0x8020109),BYTE3(0x8020109),BYTE4(0x8020109)
	.DB  LOW(0x3C545414),HIGH(0x3C545414),BYTE3(0x3C545414),BYTE4(0x3C545414)
	.DB  LOW(0x404087F),HIGH(0x404087F),BYTE3(0x404087F),BYTE4(0x404087F)
	.DB  LOW(0x7D440078),HIGH(0x7D440078),BYTE3(0x7D440078),BYTE4(0x7D440078)
	.DB  LOW(0x40200040),HIGH(0x40200040),BYTE3(0x40200040),BYTE4(0x40200040)
	.DB  LOW(0x3D44),HIGH(0x3D44),BYTE3(0x3D44),BYTE4(0x3D44)
	.DB  LOW(0x4428107F),HIGH(0x4428107F),BYTE3(0x4428107F),BYTE4(0x4428107F)
	.DB  LOW(0x407F4100),HIGH(0x407F4100),BYTE3(0x407F4100),BYTE4(0x407F4100)
	.DB  LOW(0x18047C00),HIGH(0x18047C00),BYTE3(0x18047C00),BYTE4(0x18047C00)
	.DB  LOW(0x87C7804),HIGH(0x87C7804),BYTE3(0x87C7804),BYTE4(0x87C7804)
	.DB  LOW(0x38780404),HIGH(0x38780404),BYTE3(0x38780404),BYTE4(0x38780404)
	.DB  LOW(0x38444444),HIGH(0x38444444),BYTE3(0x38444444),BYTE4(0x38444444)
	.DB  LOW(0x1414147C),HIGH(0x1414147C),BYTE3(0x1414147C),BYTE4(0x1414147C)
	.DB  LOW(0x14140808),HIGH(0x14140808),BYTE3(0x14140808),BYTE4(0x14140808)
	.DB  LOW(0x87C7C18),HIGH(0x87C7C18),BYTE3(0x87C7C18),BYTE4(0x87C7C18)
	.DB  LOW(0x48080404),HIGH(0x48080404),BYTE3(0x48080404),BYTE4(0x48080404)
	.DB  LOW(0x20545454),HIGH(0x20545454),BYTE3(0x20545454),BYTE4(0x20545454)
	.DB  LOW(0x40443F04),HIGH(0x40443F04),BYTE3(0x40443F04),BYTE4(0x40443F04)
	.DB  LOW(0x40403C20),HIGH(0x40403C20),BYTE3(0x40403C20),BYTE4(0x40403C20)
	.DB  LOW(0x201C7C20),HIGH(0x201C7C20),BYTE3(0x201C7C20),BYTE4(0x201C7C20)
	.DB  LOW(0x3C1C2040),HIGH(0x3C1C2040),BYTE3(0x3C1C2040),BYTE4(0x3C1C2040)
	.DB  LOW(0x3C403040),HIGH(0x3C403040),BYTE3(0x3C403040),BYTE4(0x3C403040)
	.DB  LOW(0x28102844),HIGH(0x28102844),BYTE3(0x28102844),BYTE4(0x28102844)
	.DB  LOW(0x50500C44),HIGH(0x50500C44),BYTE3(0x50500C44),BYTE4(0x50500C44)
	.DB  LOW(0x64443C50),HIGH(0x64443C50),BYTE3(0x64443C50),BYTE4(0x64443C50)
	.DB  LOW(0x444C54),HIGH(0x444C54),BYTE3(0x444C54),BYTE4(0x444C54)
	.DB  LOW(0x413608),HIGH(0x413608),BYTE3(0x413608),BYTE4(0x413608)
	.DB  LOW(0x7F0000),HIGH(0x7F0000),BYTE3(0x7F0000),BYTE4(0x7F0000)
	.DB  LOW(0x36410000),HIGH(0x36410000),BYTE3(0x36410000),BYTE4(0x36410000)
	.DB  LOW(0x8080008),HIGH(0x8080008),BYTE3(0x8080008),BYTE4(0x8080008)
	.DB  LOW(0x8081C2A),HIGH(0x8081C2A),BYTE3(0x8081C2A),BYTE4(0x8081C2A)
	.DB  LOW(0x8082A1C),HIGH(0x8082A1C),BYTE3(0x8082A1C),BYTE4(0x8082A1C)

	.DSEG
_p_S1000024:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	ST   -Y,R30
	RJMP _print_char

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(64)
	ST   -Y,R30
	RCALL _Lcd_WriteCMD
	LDI  R30,LOW(176)
	ST   -Y,R30
	RCALL _Lcd_WriteCMD
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _Lcd_WriteCMD
	LDI  R30,LOW(0)
	ST   -Y,R30
	RJMP _Lcd_WriteCMD

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x4:
	ST   -Y,R30
	RJMP _Lcd_WriteCMD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0x2
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x6:
	SBI  0x8,3
	LD   R30,Y
	ST   -Y,R30
	RCALL _shiftBits
	SBI  0x8,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7:
	CBI  0x8,3
	LD   R30,Y
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x8:
	SBI  0x8,3
	RJMP SUBOPT_0x7


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
