
;CodeVisionAVR C Compiler V1.25.8 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8L
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : float, width, precision
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8L
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "main.vec"
	.INCLUDE "main.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V2.03.9 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project :
;       9 Version :
;      10 Date    : 30.09.2011
;      11 Author  : Admin
;      12 Company : Microsoft
;      13 Comments:
;      14 
;      15 
;      16 Chip type               : ATmega8L
;      17 Program type            : Application
;      18 AVR Core Clock frequency: 4,000000 MHz
;      19 Memory model            : Small
;      20 External RAM size       : 0
;      21 Data Stack size         : 256
;      22 *****************************************************/
;      23 
;      24 #include <mega8.h>
;      25 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      26 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      27 	.EQU __se_bit=0x80
	.EQU __se_bit=0x80
;      28 	.EQU __sm_mask=0x70
	.EQU __sm_mask=0x70
;      29 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      30 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      31 	.EQU __sm_standby=0x60
	.EQU __sm_standby=0x60
;      32 	.EQU __sm_ext_standby=0x70
	.EQU __sm_ext_standby=0x70
;      33 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      34 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      35 	#endif
	#endif
;      36 #include <1100.h>
;      37 #include <stdio.h>
;      38 #include <delay.h>
;      39 
;      40 // I2C Bus functions
;      41 #asm
;      42    .equ __i2c_port=0x15 ;PORTC
   .equ __i2c_port=0x15 ;PORTC
;      43    .equ __sda_bit=4
   .equ __sda_bit=4
;      44    .equ __scl_bit=5
   .equ __scl_bit=5
;      45 #endasm
;      46 #include <i2c.h>
;      47 
;      48 
;      49 
;      50 bit fflag = 1;  // 
;      51 unsigned char mode;
;      52 
;      53 #define UP_Button    (!PINC.2)  //   
;      54 #define DOWN_Button  (!PINC.3)  //   
;      55 #define MODE_Button  (!PINC.0)  //    
;      56 #define MUTE_Button  (!PINC.1)  //   mute
;      57 
;      58 //,     
;      59 #define KEY_NULL      0
;      60 
;      61 char val = 0;
;      62 
;      63 const char m_about = 0,

	.CSEG
;      64 m_vol = 1,
;      65 m_trbl = 2,
;      66 m_bass = 3,
;      67 m_set = 4;
;      68 //m_mute = 5;
;      69 
;      70 char about, vol, trbl, bass, set, mute = 0, vol_tmp;
;      71 double timer=0;

	.DSEG
_timer:
	.BYTE 0x4
;      72 
;      73 const char vl_adr = 0b00000101,

	.CSEG
;      74 vr_adr = 0b00000110,
;      75 t_adr = 0b00000100,
;      76 b_adr = 0b00000011,
;      77 s_adr = 0b00000001;
;      78 
;      79 
;      80 
;      81 flash char b_val[15] = {
;      82 0b00010000,
;      83 0b00010001,
;      84 0b00010010,
;      85 0b00010011,
;      86 0b00010100,
;      87 0b00010101,
;      88 0b00010110,
;      89 0b00010111,
;      90 0b00011110,
;      91 0b00011101,
;      92 0b00011100,
;      93 0b00011011,
;      94 0b00011010,
;      95 0b00011001,
;      96 0b00011000
;      97 };
;      98 
;      99 flash char t_val[15] = {
;     100 0b00001110,
;     101 0b00011110,
;     102 0b00101110,
;     103 0b00111110,
;     104 0b01001110,
;     105 0b01011110,
;     106 0b01101110,
;     107 0b01111110,
;     108 0b11101110,
;     109 0b11011110,
;     110 0b11001110,
;     111 0b10111110,
;     112 0b10101110,
;     113 0b10011110,
;     114 0b10001110
;     115 };
;     116 
;     117 flash char v_val[20] = {
;     118 0b00000000,
;     119 0b00000100,
;     120 0b00001000,
;     121 0b00001100,
;     122 0b00010000,
;     123 0b00010100,
;     124 0b00011000,
;     125 0b00011100,
;     126 0b00100000,
;     127 0b00100100,
;     128 0b00101000,
;     129 0b00101100,
;     130 0b00110000,
;     131 0b00110100,
;     132 0b00111000,
;     133 0b00111100,
;     134 0b01000000,
;     135 0b01000100,
;     136 0b01001000,
;     137 0b01001100
;     138 };
;     139 
;     140 static const char v_val_t[20] =
;     141 {0,-4,-8,-12,-16,-20,-24,-28,-32,-36,
;     142 -40,-44,-48,-52,-56,-60,-64,-68,-72,-76 };
;     143 
;     144 unsigned char Mode_Change_Enabled = 1;    //   

	.DSEG
;     145 
;     146 static const char volum[20] ={

	.CSEG
;     147 0xFA,0x8C,0xF8,0x54,0x22,0x51,0xFF,0x04,0x02,0x00,
;     148 0x02,0x01,0x00,0x01,0x02,0x04,0x07,0x01,0x02,0x00
;     149 };
;     150 
;     151 //static const char trble[10] ={
;     152 //0xF8,0xF0,0xEC,0xCC,0x83,0x83,0xCC,0xEC,0xF0,0xF8
;     153 //};
;     154 
;     155 void tda_send(char sba, char dt)
;     156 {
_tda_send:
	PUSH R15
;     157    i2c_start();
;	sba -> Y+1
;	dt -> Y+0
	RCALL _i2c_start
;     158    i2c_write(0b10000000);
	LDI  R30,LOW(128)
	ST   -Y,R30
	RCALL _i2c_write
;     159    i2c_write(sba);
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _i2c_write
;     160    i2c_write(dt);
	LD   R30,Y
	ST   -Y,R30
	RCALL _i2c_write
;     161    i2c_stop();
	RCALL _i2c_stop
;     162 }
	ADIW R28,2
	RET
;     163 eeprom char e_vol;

	.ESEG
_e_vol:
	.DB  0x0
;     164 eeprom char e_bass;
_e_bass:
	.DB  0x0
;     165 eeprom char e_trbl;
_e_trbl:
	.DB  0x0
;     166 eeprom char e_set;
_e_set:
	.DB  0x0
;     167 // Timer 1 output compare A interrupt service routine
;     168 interrupt [TIM1_COMPA] void timer1_compa_isr(void)
;     169 {

	.CSEG
_timer1_compa_isr:
;     170 // Place your code here
;     171 TCNT1H=0;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     172 TCNT1L=0;
	OUT  0x2C,R30
;     173 sek++;
;     174 }
	RETI
;     175 
;     176 // Declare your global variables here
;     177 
;     178 void main(void)
;     179 {
_main:
;     180 // Declare your local variables here
;     181 
;     182 // Input/Output Ports initialization
;     183 // Port B initialization
;     184 // Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=In Func0=In
;     185 // State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=P State0=P
;     186 PORTB=0x03;
	LDI  R30,LOW(3)
	OUT  0x18,R30
;     187 DDRB=0x3C;
	LDI  R30,LOW(60)
	OUT  0x17,R30
;     188 
;     189 // Port C initialization
;     190 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     191 // State6=T State5=T State4=T State3=T State2=T State1=P State0=P
;     192 PORTC=0x0F;
	LDI  R30,LOW(15)
	OUT  0x15,R30
;     193 DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
;     194 
;     195 // Port D initialization
;     196 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     197 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     198 PORTD=0x00;
	OUT  0x12,R30
;     199 DDRD=0x00;
	OUT  0x11,R30
;     200 
;     201 // Timer/Counter 0 initialization
;     202 // Clock source: System Clock
;     203 // Clock value: Timer 0 Stopped
;     204 TCCR0=0x00;
	OUT  0x33,R30
;     205 TCNT0=0x00;
	OUT  0x32,R30
;     206 
;     207 // Timer/Counter 1 initialization
;     208 // Clock source: System Clock
;     209 // Clock value: Timer 1 Stopped
;     210 // Mode: Normal top=FFFFh
;     211 // OC1A output: Discon.
;     212 // OC1B output: Discon.
;     213 // Noise Canceler: Off
;     214 // Input Capture on Falling Edge
;     215 // Timer 1 Overflow Interrupt: Off
;     216 // Input Capture Interrupt: Off
;     217 // Compare A Match Interrupt: Off
;     218 // Compare B Match Interrupt: Off
;     219 TCCR1A=0x00;
	OUT  0x2F,R30
;     220 TCCR1B=0x03;
	LDI  R30,LOW(3)
	OUT  0x2E,R30
;     221 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     222 TCNT1L=0x00;
	OUT  0x2C,R30
;     223 ICR1H=0x00;
	OUT  0x27,R30
;     224 ICR1L=0x00;
	OUT  0x26,R30
;     225 OCR1AH=0x00;
	OUT  0x2B,R30
;     226 OCR1AL=0x00;
	OUT  0x2A,R30
;     227 OCR1BH=0x00;
	OUT  0x29,R30
;     228 OCR1BL=0x00;
	OUT  0x28,R30
;     229 
;     230 // Timer/Counter 2 initialization
;     231 // Clock source: System Clock
;     232 // Clock value: Timer 2 Stopped
;     233 // Mode: Normal top=FFh
;     234 // OC2 output: Disconnected
;     235 ASSR=0x00;
	OUT  0x22,R30
;     236 TCCR2=0x00;
	OUT  0x25,R30
;     237 TCNT2=0x00;
	OUT  0x24,R30
;     238 OCR2=0x00;
	OUT  0x23,R30
;     239 
;     240 // External Interrupt(s) initialization
;     241 // INT0: Off
;     242 // INT1: Off
;     243 MCUCR=0x00;
	OUT  0x35,R30
;     244 
;     245 // Timer(s)/Counter(s) Interrupt(s) initialization
;     246 TIMSK=0x10;
	LDI  R30,LOW(16)
	OUT  0x39,R30
;     247 
;     248 // Analog Comparator initialization
;     249 // Analog Comparator: Off
;     250 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     251 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     252 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     253 
;     254 
;     255 
;     256 // I2C Bus initialization
;     257 i2c_init();
	RCALL _i2c_init
;     258 
;     259 lcd_init();
	RCALL _lcd_init
;     260 mode = 0;
	CLR  R5
;     261 vol = e_vol;
	LDI  R26,LOW(_e_vol)
	LDI  R27,HIGH(_e_vol)
	RCALL __EEPROMRDB
	MOV  R6,R30
;     262 trbl = e_trbl;
	LDI  R26,LOW(_e_trbl)
	LDI  R27,HIGH(_e_trbl)
	RCALL __EEPROMRDB
	MOV  R9,R30
;     263 bass = e_bass;
	LDI  R26,LOW(_e_bass)
	LDI  R27,HIGH(_e_bass)
	RCALL __EEPROMRDB
	MOV  R8,R30
;     264 set = e_set;
	LDI  R26,LOW(_e_set)
	LDI  R27,HIGH(_e_set)
	RCALL __EEPROMRDB
	MOV  R11,R30
;     265 
;     266 lcd_clear();
	RCALL _lcd_clear
;     267 
;     268 //tda_send(s_adr, s_val[surr]);
;     269 tda_send(vl_adr, v_val[vol]);
	LDI  R30,LOW(_vl_adr*2)
	LDI  R31,HIGH(_vl_adr*2)
	LPM  R30,Z
	ST   -Y,R30
	MOV  R30,R6
	LDI  R31,0
	SUBI R30,LOW(-_v_val*2)
	SBCI R31,HIGH(-_v_val*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _tda_send
;     270 tda_send(vr_adr, v_val[vol]);
	LDI  R30,LOW(_vr_adr*2)
	LDI  R31,HIGH(_vr_adr*2)
	LPM  R30,Z
	ST   -Y,R30
	MOV  R30,R6
	LDI  R31,0
	SUBI R30,LOW(-_v_val*2)
	SBCI R31,HIGH(-_v_val*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _tda_send
;     271 tda_send(t_adr, t_val[trbl]);
	LDI  R30,LOW(_t_adr*2)
	LDI  R31,HIGH(_t_adr*2)
	LPM  R30,Z
	ST   -Y,R30
	MOV  R30,R9
	LDI  R31,0
	SUBI R30,LOW(-_t_val*2)
	SBCI R31,HIGH(-_t_val*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _tda_send
;     272 tda_send(b_adr, b_val[bass]);
	LDI  R30,LOW(_b_adr*2)
	LDI  R31,HIGH(_b_adr*2)
	LPM  R30,Z
	ST   -Y,R30
	MOV  R30,R8
	LDI  R31,0
	SUBI R30,LOW(-_b_val*2)
	SBCI R31,HIGH(-_b_val*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _tda_send
;     273 tda_send(0x00, 0x00);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	RCALL _tda_send
;     274 
;     275 
;     276 #asm("sei")
	sei
;     277 while (1)
_0x4:
;     278       {
;     279       // Place your code here
;     280       unsigned char i;
;     281       unsigned char key;
;     282       //***********************************
;     283 
;     284       //  .
;     285        if(sek==60) //   = 60
	SBIW R28,2
;	i -> Y+1
;	key -> Y+0
	__CPD1N 0x42700000
	BREQ PC+2
	RJMP _0x7
;     286        {
;     287        minut++; //  1   ""
;     288        sek=0; //   ""
	LDI  R30,LOW(0)
;     289        }
;     290        if(minut==60) //   = 60
_0x7:
	__CPD1N 0x42700000
	BREQ PC+2
	RJMP _0x8
;     291        {
;     292        hour++; //  1   ""
;     293        minut=0; //   ""
	LDI  R30,LOW(0)
;     294        }
;     295        if (hour==24) //       24  
_0x8:
	__CPD1N 0x41C00000
	BREQ PC+2
	RJMP _0x9
;     296        { //   24 ,   .
;     297        hour=0;
	LDI  R30,LOW(0)
;     298        minut=0;
;     299        sek=0;
;     300        }
;     301        //   ,             .
;     302        if (hour==255)
_0x9:
	__CPD1N 0x437F0000
	BREQ PC+2
	RJMP _0xA
;     303        hour=0;
_0xA:
	LDI  R30,LOW(0)
;     304        if (minut==255)
	__CPD1N 0x437F0000
	BREQ PC+2
	RJMP _0xB
;     305        minut=0;
_0xB:
	LDI  R30,LOW(0)
;     306        //***********************************
;     307 
;     308        // 
;     309        if((mode != 0)&&(KEY_NULL)&&(timer < 10000)) timer = timer + 1;
	CP   R30,R5
	BRNE PC+2
	RJMP _0xD
	CPI  R30,0
	BRNE PC+2
	RJMP _0xD
	LDS  R26,_timer
	LDS  R27,_timer+1
	LDS  R24,_timer+2
	LDS  R25,_timer+3
	__GETD1N 0x461C4000
	RCALL __CMPF12
	BRLO PC+2
	RJMP _0xD
	RJMP _0xE
_0xD:
	RJMP _0xC
_0xE:
	LDS  R30,_timer
	LDS  R31,_timer+1
	LDS  R22,_timer+2
	LDS  R23,_timer+3
	__GETD2N 0x3F800000
	RCALL __ADDF12
	STS  _timer,R30
	STS  _timer+1,R31
	STS  _timer+2,R22
	STS  _timer+3,R23
;     310        if(timer == 10000) {
_0xC:
	LDS  R26,_timer
	LDS  R27,_timer+1
	LDS  R24,_timer+2
	LDS  R25,_timer+3
	__CPD2N 0x461C4000
	BREQ PC+2
	RJMP _0xF
;     311        mode = 0;
	CLR  R5
;     312        timer = 0;
	__GETD1N 0x0
	STS  _timer,R30
	STS  _timer+1,R31
	STS  _timer+2,R22
	STS  _timer+3,R23
;     313        fflag = 0;
	CLT
	BLD  R2,0
;     314        lcd_clear();
	RCALL _lcd_clear
;     315        };
_0xF:
;     316        //***********************************
;     317 
;     318        // 
;     319        if (MUTE_Button) {
	SBIC 0x13,1
	RJMP _0x10
;     320          delay_ms(200);
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     321 
;     322          if (mute==0) {
	TST  R10
	BREQ PC+2
	RJMP _0x11
;     323          mute=1;
	LDI  R30,LOW(1)
	MOV  R10,R30
;     324 
;     325          gotoxy(5,1);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _gotoxy
;     326           for ( i = 0; i != 10; i++ ){
	LDI  R30,LOW(0)
	STD  Y+1,R30
_0x13:
	LDD  R26,Y+1
	CPI  R26,LOW(0xA)
	BRNE PC+2
	RJMP _0x14
;     327           gotoxy(5+i, 1);
	LDD  R30,Y+1
	LDI  R31,0
	ADIW R30,5
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _gotoxy
;     328           lcd_write(DATA,volum[i]);
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDD  R30,Y+2
	LDI  R31,0
	SUBI R30,LOW(-_volum*2)
	SBCI R31,HIGH(-_volum*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _lcd_write
;     329           gotoxy(5+i, 2);
	LDD  R30,Y+1
	LDI  R31,0
	ADIW R30,5
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _gotoxy
;     330           lcd_write(DATA,volum[10+i]);
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDD  R30,Y+2
	LDI  R31,0
	__ADDW1FN _volum,10
	LPM  R30,Z
	ST   -Y,R30
	RCALL _lcd_write
;     331           }
_0x12:
	LDD  R30,Y+1
	SUBI R30,-LOW(1)
	STD  Y+1,R30
	RJMP _0x13
_0x14:
;     332          }
;     333          else
	RJMP _0x15
_0x11:
;     334          {
;     335          mute=0;
	CLR  R10
;     336 
;     337          gotoxy(5,1); print_message("  ");
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _gotoxy
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print_message
;     338          gotoxy(5,2); print_message("  ");
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _gotoxy
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print_message
;     339          };
_0x15:
;     340 
;     341        };
_0x10:
;     342        //***********************************
;     343 
;     344        //
;     345        if ((UP_Button)&&(mode==1)) {
	SBIC 0x13,2
	RJMP _0x17
	LDI  R30,LOW(1)
	CP   R30,R5
	BREQ PC+2
	RJMP _0x17
	RJMP _0x18
_0x17:
	RJMP _0x16
_0x18:
;     346           delay_ms(50); mute=0;
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CLR  R10
;     347           gotoxy(5,1); print_message("  ");
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _gotoxy
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print_message
;     348           gotoxy(5,2); print_message("  ");
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _gotoxy
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print_message
;     349 
;     350        };
_0x16:
;     351 
;     352        if ((DOWN_Button)&&(mode==1)) {
	SBIC 0x13,3
	RJMP _0x1A
	LDI  R30,LOW(1)
	CP   R30,R5
	BREQ PC+2
	RJMP _0x1A
	RJMP _0x1B
_0x1A:
	RJMP _0x19
_0x1B:
;     353           delay_ms(50); mute=0;
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CLR  R10
;     354           gotoxy(5,1); print_message("  ");
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _gotoxy
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print_message
;     355           gotoxy(5,2); print_message("  ");
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _gotoxy
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print_message
;     356 
;     357        };
_0x19:
;     358       //****************************************
;     359 
;     360       // 
;     361       if (Mode_Change_Enabled)
	TST  R12
	BRNE PC+2
	RJMP _0x1C
;     362         {
;     363             if (MODE_Button)                    //     
	SBIC 0x13,0
	RJMP _0x1D
;     364             {   delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     365                 if ((mode++) == 4) mode = 0;    //   
	MOV  R30,R5
	INC  R5
	CPI  R30,LOW(0x4)
	BREQ PC+2
	RJMP _0x1E
	CLR  R5
;     366                 Mode_Change_Enabled = 0;        //      
_0x1E:
	CLR  R12
;     367               fflag = 1;
	SET
	BLD  R2,0
;     368             };
_0x1D:
;     369         }
;     370         //   ,    
;     371         else if (!MODE_Button) {Mode_Change_Enabled = 1;};
	RJMP _0x1F
_0x1C:
	SBIS 0x13,0
	RJMP _0x20
	LDI  R30,LOW(1)
	MOV  R12,R30
_0x20:
_0x1F:
;     372       //*****************************************
;     373 
;     374       //  (about)
;     375        if ((mode == 0) && (fflag == 1)) {
	LDI  R30,LOW(0)
	CP   R30,R5
	BREQ PC+2
	RJMP _0x22
	SBRS R2,0
	RJMP _0x22
	RJMP _0x23
_0x22:
	RJMP _0x21
_0x23:
;     376        lcd_clear();
	RCALL _lcd_clear
;     377 
;     378        //
;     379        char_12_16(hour/10,20,1);
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x41200000
	RCALL __DIVF21
	RCALL __CFD1U
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _char_12_16
;     380        char_12_16(hour%10,32,1);
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x41200000
	RCALL __CFD1U
	ST   -Y,R30
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _char_12_16
;     381        char_12_16(minut/10,50,1);
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x41200000
	RCALL __DIVF21
	RCALL __CFD1U
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _char_12_16
;     382        char_12_16(minut%10,62,1);
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x41200000
	RCALL __CFD1U
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _char_12_16
;     383        delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     384 
;     385        //gotoxy(25,4); //print_message(" 220");
;     386        //gotoxy(3,6); print_message("               ");
;     387 
;     388        //gotoxy(5,6);
;     389          // for ( i = 0; i < 10; i++ ){
;     390           //gotoxy(5, 1);
;     391           //lcd_write(DATA,trble[i]);
;     392 
;     393           //}
;     394        //gotoxy(15,6); print_message("-           ");
;     395        //sprintf( TrblBuffer,"%d", trbl );
;     396        //gotoxy(15,6); print_string(TrblBuffer);
;     397 
;     398        fflag = 0;
	CLT
	BLD  R2,0
;     399        };
_0x21:
;     400       //*****************************************
;     401 
;     402       //   (volum)
;     403        if ((mode==1)&&(fflag==1)) {
	LDI  R30,LOW(1)
	CP   R30,R5
	BREQ PC+2
	RJMP _0x25
	SBRS R2,0
	RJMP _0x25
	RJMP _0x26
_0x25:
	RJMP _0x24
_0x26:
;     404        lcd_clear(); vol = vol_tmp;
	RCALL _lcd_clear
	MOV  R6,R13
;     405         gotoxy(20,3); print_message("");
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _gotoxy
	__POINTW1FN _0,3
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print_message
;     406 
;     407        //gotoxy(15,5); print_char(vol);
;     408          //char_12_16(vol,15,5);
;     409          if((UP_Button)&(vol < 19)) vol++;
	LDI  R30,0
	SBIS 0x13,2
	LDI  R30,1
	MOV  R0,R30
	MOV  R26,R6
	LDI  R30,LOW(19)
	RCALL __LTB12U
	LDI  R31,0
	MOV  R26,R0
	LDI  R27,0
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BRNE PC+2
	RJMP _0x27
	INC  R6
;     410          if((DOWN_Button)&(vol > 0)) vol--;
_0x27:
	LDI  R30,0
	SBIS 0x13,3
	LDI  R30,1
	MOV  R0,R30
	MOV  R26,R6
	LDI  R30,LOW(0)
	RCALL __GTB12U
	LDI  R31,0
	MOV  R26,R0
	LDI  R27,0
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BRNE PC+2
	RJMP _0x28
	DEC  R6
;     411          tda_send(vl_adr, v_val[vol]);
_0x28:
	LDI  R30,LOW(_vl_adr*2)
	LDI  R31,HIGH(_vl_adr*2)
	LPM  R30,Z
	ST   -Y,R30
	MOV  R30,R6
	LDI  R31,0
	SUBI R30,LOW(-_v_val*2)
	SBCI R31,HIGH(-_v_val*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _tda_send
;     412          tda_send(vr_adr, v_val[vol]);
	LDI  R30,LOW(_vr_adr*2)
	LDI  R31,HIGH(_vr_adr*2)
	LPM  R30,Z
	ST   -Y,R30
	MOV  R30,R6
	LDI  R31,0
	SUBI R30,LOW(-_v_val*2)
	SBCI R31,HIGH(-_v_val*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _tda_send
;     413          //gotoxy(3,5); print_string(v_val_t);
;     414          //e_vol = vol;
;     415 
;     416        fflag = 0;
	CLT
	BLD  R2,0
;     417        timer = 0;
	__GETD1N 0x0
	STS  _timer,R30
	STS  _timer+1,R31
	STS  _timer+2,R22
	STS  _timer+3,R23
;     418        };
_0x24:
;     419       //*****************************************
;     420 
;     421       //   (trbl)
;     422        if ((mode==2)&&(fflag==1)) {
	LDI  R30,LOW(2)
	CP   R30,R5
	BREQ PC+2
	RJMP _0x2A
	SBRS R2,0
	RJMP _0x2A
	RJMP _0x2B
_0x2A:
	RJMP _0x29
_0x2B:
;     423        lcd_clear();
	RCALL _lcd_clear
;     424          gotoxy(20,3); print_message("   ");
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _gotoxy
	__POINTW1FN _0,13
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print_message
;     425          //gotoxy(15,5); print_char(trbl);
;     426          //char_12_16('00',15,5);
;     427          if((UP_Button)&(trbl < 14)) trbl++;
	LDI  R30,0
	SBIS 0x13,2
	LDI  R30,1
	MOV  R0,R30
	MOV  R26,R9
	LDI  R30,LOW(14)
	RCALL __LTB12U
	LDI  R31,0
	MOV  R26,R0
	LDI  R27,0
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BRNE PC+2
	RJMP _0x2C
	INC  R9
;     428          if((DOWN_Button)&(trbl > 0)) trbl--;
_0x2C:
	LDI  R30,0
	SBIS 0x13,3
	LDI  R30,1
	MOV  R0,R30
	MOV  R26,R9
	LDI  R30,LOW(0)
	RCALL __GTB12U
	LDI  R31,0
	MOV  R26,R0
	LDI  R27,0
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BRNE PC+2
	RJMP _0x2D
	DEC  R9
;     429          tda_send(t_adr, t_val[trbl]);
_0x2D:
	LDI  R30,LOW(_t_adr*2)
	LDI  R31,HIGH(_t_adr*2)
	LPM  R30,Z
	ST   -Y,R30
	MOV  R30,R9
	LDI  R31,0
	SUBI R30,LOW(-_t_val*2)
	SBCI R31,HIGH(-_t_val*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _tda_send
;     430 
;     431        fflag = 0;
	CLT
	BLD  R2,0
;     432        timer = 0;
	__GETD1N 0x0
	STS  _timer,R30
	STS  _timer+1,R31
	STS  _timer+2,R22
	STS  _timer+3,R23
;     433        };
_0x29:
;     434        //*****************************************
;     435 
;     436       //   (bass)
;     437        if ((mode==3)&&(fflag==1)) {
	LDI  R30,LOW(3)
	CP   R30,R5
	BREQ PC+2
	RJMP _0x2F
	SBRS R2,0
	RJMP _0x2F
	RJMP _0x30
_0x2F:
	RJMP _0x2E
_0x30:
;     438        lcd_clear();
	RCALL _lcd_clear
;     439          gotoxy(20,3); print_message("   ");
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _gotoxy
	__POINTW1FN _0,24
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print_message
;     440          //gotoxy(3,6); print_char(bass);
;     441          if((UP_Button)&(bass < 14)) bass++;
	LDI  R30,0
	SBIS 0x13,2
	LDI  R30,1
	MOV  R0,R30
	MOV  R26,R8
	LDI  R30,LOW(14)
	RCALL __LTB12U
	LDI  R31,0
	MOV  R26,R0
	LDI  R27,0
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BRNE PC+2
	RJMP _0x31
	INC  R8
;     442          if((DOWN_Button)&(bass > 0)) bass--;
_0x31:
	LDI  R30,0
	SBIS 0x13,3
	LDI  R30,1
	MOV  R0,R30
	MOV  R26,R8
	LDI  R30,LOW(0)
	RCALL __GTB12U
	LDI  R31,0
	MOV  R26,R0
	LDI  R27,0
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BRNE PC+2
	RJMP _0x32
	DEC  R8
;     443          tda_send(b_adr, b_val[bass]);
_0x32:
	LDI  R30,LOW(_b_adr*2)
	LDI  R31,HIGH(_b_adr*2)
	LPM  R30,Z
	ST   -Y,R30
	MOV  R30,R8
	LDI  R31,0
	SUBI R30,LOW(-_b_val*2)
	SBCI R31,HIGH(-_b_val*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _tda_send
;     444 
;     445        fflag = 0;
	CLT
	BLD  R2,0
;     446        timer = 0;
	__GETD1N 0x0
	STS  _timer,R30
	STS  _timer+1,R31
	STS  _timer+2,R22
	STS  _timer+3,R23
;     447        };
_0x2E:
;     448       //*****************************************
;     449 
;     450       //  (set)
;     451        if ((mode==4)&&(fflag==1)) {
	LDI  R30,LOW(4)
	CP   R30,R5
	BREQ PC+2
	RJMP _0x34
	SBRS R2,0
	RJMP _0x34
	RJMP _0x35
_0x34:
	RJMP _0x33
_0x35:
;     452        lcd_clear();
	RCALL _lcd_clear
;     453          gotoxy(20,2); print_message(" ");
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _gotoxy
	__POINTW1FN _0,34
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print_message
;     454          gotoxy(25,3); print_message(" ");
	LDI  R30,LOW(25)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _gotoxy
	__POINTW1FN _0,45
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print_message
;     455          gotoxy(30,6); print_message("00 00");
	LDI  R30,LOW(30)
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _gotoxy
	__POINTW1FN _0,54
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print_message
;     456 
;     457        fflag = 0;
	CLT
	BLD  R2,0
;     458        timer = 0;
	__GETD1N 0x0
	STS  _timer,R30
	STS  _timer+1,R31
	STS  _timer+2,R22
	STS  _timer+3,R23
;     459        };
_0x33:
;     460 
;     461 
;     462 
;     463 
;     464      };
	ADIW R28,2
	RJMP _0x4
_0x6:
;     465 }
_0x36:
	RJMP _0x36
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,7
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,13
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LTB12U:
	CP   R26,R30
	LDI  R30,1
	BRLO __LTB12U1
	CLR  R30
__LTB12U1:
	RET

__GTB12U:
	CP   R30,R26
	LDI  R30,1
	BRLO __GTB12U1
	CLR  R30
__GTB12U1:
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

;END OF CODE MARKER
__END_OF_CODE:
