/*
 _   _    ___    _  __  ___      _          _   _    ___     ___        _       ____   ____
| \ | |  / _ \  | |/ / |_ _|    / \        / | / |  / _ \   / _ \      | |     / ___| |  _ \
|  \| | | | | | | ' /   | |    / _ \       | | | | | | | | | | | |     | |    | |     | | | |
| |\  | | |_| | | . \   | |   / ___ \      | | | | | |_| | | |_| |     | |___ | |___  | |_| |
|_| \_|  \___/  |_|\_\ |___| /_/   \_\     |_| |_|  \___/   \___/      |_____| \____| |____/

PIC 18f1320 to Nokia 1100 LCD Interface
http://sunbizhosting.com/~spiral/

File: lcd1100.h

*/
#include <p18f1320.h>
#include <delays.h> 
#include <string.h>

// set output pins for lcd here
#define sclk 	PORTBbits.RB3
#define sda 	PORTBbits.RB5
#define cs 		PORTBbits.RB6
#define rst 	PORTBbits.RB7

#define CMD		0
#define DATA	1


void init(void); 
void Lcd_Init(void);
void Lcd_Write(char cd,unsigned char c);
void Lcd_Clear(void);
void SetX(char x);
void SetY(char y);
void Gotoxy(char x,char y);
void VLine(char x,char y,char on);
void Line(unsigned char x,unsigned char y,unsigned char y2,unsigned char on);
void print_message(const rom char* message);
void print_char(char c);
void print_string(char * message);
