/*
 _   _    ___    _  __  ___      _          _   _    ___     ___        _       ____   ____
| \ | |  / _ \  | |/ / |_ _|    / \        / | / |  / _ \   / _ \      | |     / ___| |  _ \
|  \| | | | | | | ' /   | |    / _ \       | | | | | | | | | | | |     | |    | |     | | | |
| |\  | | |_| | | . \   | |   / ___ \      | | | | | |_| | | |_| |     | |___ | |___  | |_| |
|_| \_|  \___/  |_|\_\ |___| /_/   \_\     |_| |_|  \___/   \___/      |_____| \____| |____/

PIC 18f1320 to Nokia 1100 LCD Interface
http://sunbizhosting.com/~spiral/

File: main.c

*/

#include <p18f1320.h> /* Register and bit declarations */ 
#include <delays.h>  
#include <string.h>
#include "lcd1100.h"


#pragma config WDT = OFF
#pragma config OSC = INTIO2
#pragma config MCLRE = OFF
#pragma config PWRT = ON
#pragma config DEBUG= OFF
#pragma config LVP = OFF
#pragma config FSCM = OFF
#pragma config IESO = OFF
#pragma config BOR = OFF
#pragma config STVR = OFF
#pragma config CP0 = OFF
#pragma config CP1 = OFF
#pragma config CPB = OFF
#pragma config CPD = OFF
#pragma config WRT0 = OFF
#pragma config WRT1 = OFF
#pragma config WRTB = OFF
#pragma config WRTC = OFF
#pragma config WRTD = OFF
#pragma config EBTR0 = OFF
#pragma config EBTR1 = OFF
#pragma config EBTRB = OFF




typedef unsigned char BYTE; 
//// Constant declarations 
#define CLOCK 8	//clock in MHz

char p[7];


void main(void);
void InterruptHandlerHigh(void);
void init (void);
void long_to_string_lz (unsigned int input, char *str, char numdigits);
void long_to_string (unsigned int input, char *str, char numdigits);


void main (void) {

	OSCCON = 0x72;                  //8MHz clock
    while(!OSCCONbits.IOFS);        //wait for osc stable
	
	init();
	Lcd_Init();
	Gotoxy(0,0);
	print_message("Hello, world!!  demo of Nokia     1100 LCD ..");
	Gotoxy(20,5);
	print_message("It works!!");


while(1) {
}
 					}



void init (void) {


/* 
* initialise system variables. 
*/
		TRISAbits.TRISA0 = 1;
		TRISAbits.TRISA1 = 1;
		TRISAbits.TRISA3 = 1;
		TRISAbits.TRISA6 = 0;
		TRISAbits.TRISA7 = 0;
		
		TRISBbits.TRISB0 = 0;
		TRISBbits.TRISB1 = 0; 
		TRISBbits.TRISB2 = 0; 
		TRISBbits.TRISB3 = 0; 
		TRISBbits.TRISB4 = 0; 
		TRISBbits.TRISB5 = 0; 
		TRISBbits.TRISB6 = 0; 
		TRISBbits.TRISB7 = 0; 




		return;
			}



/*
*********************************************************************************************************
* long_to_string()
*
* Description : Convert a "long" to a null-terminated string
*               (base = decimal)
* Arguments   : input = number to be converted
*               str = pointer to string (i.e. display buffer)
*               numdigits = number of digits to display
* Returns     : none
*********************************************************************************************************
*/
void long_to_string (unsigned int input, char *str, char numdigits)
{
  char digit;
  int blank = 1;
  long_to_string_lz(input, str, numdigits);
  for (digit=0; digit < numdigits-1; digit++) {
    if (str[digit] == '0') {
      if (blank == 1) str[digit] = ' ';
    }
    else {
      blank = 0;
    }
  }
}


/*
*********************************************************************************************************
* long_to_string_lz()
*
* Description : Convert a "long" to a null-terminated string, with leading zeros
*               (base = decimal)
* Arguments   : input = number to be converted
*               str = pointer to string (i.e. display buffer)
*               numdigits = number of digits to display
* Returns     : none
*********************************************************************************************************
*/
void long_to_string_lz (unsigned int input, char *str, char numdigits)
{
  char digit;
  for (digit=numdigits; digit > 0; digit--) {
    str[digit-1] = (input % 10) + '0';
    input = input / 10;
  }
  str[numdigits] = 0;    // null-terminate the string
}
